;include z_romboot
 org 04000h
 db 41h, 42h
 dw rom.init
 ds 12,0
rom.init:
 call cpslt
 jp _main     
;include z_ctrl
rom.ENASLT EQU 0024H
rom.RSLREG EQU 0138H
rom.EXPTBL EQU 0FCC1H
rdslt:
 ex de,hl
;DE=PGxx xxxx xxxx xxxx
;page*2
  srl d;page*2
  srl d;page*2
  srl d;page*2
  srl d;page*2
  srl d;page*2
;DE=xxxx xPGx xxxx xxxx
 CALL rom.RSLREG
;A = PRIMARY_SLOT
 ld e,d
;A >>= PG*2
rom.rdslt1:
  RRCA
  dec e
  jp nz,rom.rdslt1
 AND    00000011B
 LD c,A;000000Pr
 LD B,0
 LD HL,rom.EXPTBL
 ADD HL,BC
 LD c,A;000000Pr
 LD A,(HL)
 AND 80H;expand flag
 OR c
 bit 7,a
 ret z
 LD c,A;e00000Pr
  INC HL
  INC HL
  INC HL
  INC HL
 LD A,(HL);exp reg
 ld e,d
rom.rdslt2:
  srl a
  dec e
  jp nz,rom.rdslt2
;000000Ex
 sla a
 sla a
;0000Ex00
 and  00001100b
 OR c;e000ExPr
 ret
cpwork equ 0c000h
cplen equ 01000h
rom equ cpwork+cplen
ram equ rom+1
ramtop equ 8000h
cpslt:
 ld hl,4000h
 call rdslt
 ld (rom),a
 ld hl,cpwork
 call rdslt
 ld (ram),a
 ld hl,rom
 cp (hl)
 ret z
 ld hl,ramtop 
cpslt.loop:
  push hl
  ld a,(rom)
  ld hl,ramtop 
  call rom.ENASLT
  pop hl
  push hl
  ld bc,cplen
  ld de,cpwork
  ldir
  ld a,(ram)
  ld hl,ramtop 
  call rom.ENASLT
  ld hl,cpwork
  pop de
  ld bc,cplen
  ldir
  ex de,hl
  ld a,h
  cp 0c0h
  jr c,cpslt.loop
 ret
;!INCLUDE_ROM
; ds 8000h-$, 0
;end of include z_romboot
;include z_tnu
;include z_spr
;include z_const
;wrt equ 0a2h
dcompr equ 0020H
sp.ini.h  equ 0dch
sp.ini    equ sp.ini.h*256
stksize.h equ 2
stksize   equ stksize.h*256
th.size.h   equ 1
th.size     equ th.size.h*256
th.count equ 32
th.end.h    equ sp.ini.h-stksize.h
th.end      equ th.end.h*256
th.start.h  equ th.end.h-th.count*th.size.h
th.start    equ th.start.h*256
MZO.PSGs    equ th.start
MZO.ch1     equ MZO.PSGs+256
MZO.ch2     equ MZO.ch1+256
MZO.ch3     equ MZO.ch2+256
MZO.chs     equ MZO.ch3+256
th.bottom equ 0
spr.scale equ 1
spr.xmax equ 256<<spr.scale
spr.ymax equ 192<<spr.scale
space.char equ 1
ENASLT EQU 0024H
RSLREG EQU 0138H
EXPTBL EQU 0FCC1H
SETWRT equ 0053H
filvrm equ 0056H
LDIRVM equ 005CH
WRTVDP equ 0047H
RG1SAV equ 0F3E0H
RDVDP  equ 013EH
SNSMAT.a equ 0141h
CHGMOD equ 005FH
IMULT.a equ 3193H;HL ← DE*HL
IDIV.a equ 31E6H;HL ← DE/HL
IMOD.a equ 323AH;HL ← DE mod HL (DE ← DE/HL)
WRTPSG  equ 0093H
CSRY equ 0F3DCH
CSRX equ 0F3DDH
null equ 0
;last.marker: defl $
;len.##n: defl $-last.marker
;end of include z_const
;include z_th
;include z_ctrl
freeze:
 halt
 jr freeze
; uses a
; c: breaked
; uses a
iff.nz equ 0
iff.z  equ 1
iff.nc equ 2
iff.c  equ 3
;jr cnd, skip
;jr to
;skip:
; call hl
;trace mesg
; unreach &lb
h.unreach.default:
 ld a,'u'
 ld hl,1800h
 call 4dh
 dw 0x18,0xfe
 ret
h.nop:
 ret
;end of include z_ctrl
;include z_sp
;include z_mem
;end of include z_mem
;include z_debug
;include z_math
;16bit shifts
xrnd.a:
; h l d e
 ld hl,(xrnd.seed+2)
 ld de,(xrnd.seed)
; s[0] ^= s[0] << 13
 push de
 pop bc
; h l d e
; b c
 ld a,l
  srl a
  rr b
  rr c
  srl a
  rr b
  rr c
  srl a
  rr b
  rr c
 ld a,h
 xor b
 ld h,a
 ld a,l
 xor c
 ld l,a
; s[0] ^= s[0] >> 17
 push hl
 pop bc
; h l d e
;     b c
 srl b
 rr c
 ld a,d
 xor b
 ld d,a
 ld a,e
 xor c
 ld e,a
; s[0] ^= s[0] << 5;
; h l d e
;   b c
 ld b,l
 ld c,d
 ld a,e
  srl a
  rr b
  rr c
  srl a
  rr b
  rr c
  srl a
  rr b
  rr c
 ld a,l
 xor b
 ld l,a
 ld a,d
 xor c
 ld d,a
 ld (xrnd.seed+2),hl
 ld (xrnd.seed),de
 ret
 ret
rnd:
 push af
 call rnd.a
 pop af
 ret
rnd.a:
 ex de,hl
 ld hl,07fffh
 call udiv.a
 inc bc
 push bc
 call xrnd.a
 res 7,h
 pop de
 call udiv.a
 ld h,b
 ld l,c
 ret
abs:
 bit 7,h
 ret z
neghl:
 ld de,0
 ex de,hl
 and a
 sbc hl,de
 ret
 ret
clamp:
; hl value
; bc min
; de max
 push hl
 and a
 sbc hl,bc
 bit 7,h
 pop hl
 jr z, L6.notmin
  ld h,b
  ld l,c
  ret
L6.notmin:
 push hl
 and a
 sbc hl,de
 bit 7,h
 pop hl
 ret nz
 ex de,hl
 ret
 ret
mul.a:
; hl*=de
 ld b,h
 ld c,l
 ld hl,0
L7.loop:
 srl b
 rr c
 jr nc,L7.notad
 add hl,de
L7.notad:
 sla e
 rl d
 ld a,b
 or c
 jr nz,L7.loop
 ret
log.a:
 push hl
 ld a,16
L8.loop:
 dec A
 sla l
 rl h
 jr nc,L8.loop
 pop hl
 ret
div.a:
; hl/=de with signed
; de=remainder
 ld a,0
; hl=abs(hl), 
; a++ if hl<0
 bit 7,h
 jr z, L9.hposi
 xor 3
 push de
 call neghl
 pop de
L9.hposi:
; de=abs(de), 
; a++ if de<0
 bit 7,d
 jr z, L9.dposi
 xor 1
 ex de,hl
 push de
 call neghl
 pop de
 ex de,hl
L9.dposi:
 push af
 call udiv.a
 ex de,hl; remainder
 ld h,b
 ld l,c
 pop af
 bit 0,a
 jp z, L9.nnq
; negate quotient
 push de
 call neghl
 pop de
L9.nnq:
 bit 1,a
 jp z, L9.nnr
; negate remainder
 ex de,hl
 push de
 call neghl
 pop de
 ex de,hl
L9.nnr:
 ret
udiv.a:
; bc=hl/de
; hl=hl%de
 ld a,d
 or e
 ret z; /0 error
 ld b,0
L10.bitc.lp:
 sla e
 rl d
 inc b
 rst dcompr
 jr nc, L10.bitc.lp
L10.bitc.br:
 srl d
 rr e
 ld a,b
 ld bc,0
;ld (hexval),de
;call showhex
L10.put.lp:
 and a
 sbc hl,de
 bit 7,h
 jr z, L10.put1
L10.put0:
 add hl,de
 and a
 jr L10.puten
L10.put1:
 and a
 scf  
L10.puten:
 rl c
 rl b
 srl d
 rr e
 dec a
 jr nz, L10.put.lp 
L10.put.br:
 ret
;end of include z_math
;debug
showhex:
 push af
 push bc
 push HL
 ld hl,(hexval)
 ld b,4
L11.loop:
  xor a
 sla l
 rl h
   rla
 sla l
 rl h
   rla
 sla l
 rl h
   rla
 sla l
 rl h
   rla
  call showhex1
 djnz L11.loop
 ld a,32
 call wrt
 pop HL
 pop bc
 pop af
 ret
 ret
showhex1:
 cp 10
 jp nc, L12.els
 add a,48
 jp wrt
L12.els:
 add a,65-10
 jp wrt
 ret
abort:
 call wrt
 db 018h,0feh
 ret
trace.s:
 push af
 push hl
 ld a,(trad)
 ld hl,1ae0h
 call wrt
 call 4dh
 inc a
 ld (trad),a
 ld a,32
 call wrt
 pop hl
 pop af
 ret
showz:
 push af
 jr z,showz.s
 ld a,'N'
 call wrt
showz.s:
 ld a,'z'
 call wrt
 ld a,32
 call wrt
 pop af
 ret
showc:
 push af
 jr c,showc.s
 ld a,'N'
 call wrt
showc.s:
 ld a,'c'
 call wrt
 ld a,32
 call wrt
 pop af
 ret
wrt:
 push hl
 push af
 ld hl,(cursor)
 call 4dh
 inc hl
 ld a,h
 cp 1bh
 jr c,L13.sk
  ld h,18h
L13.sk:
 ld (cursor),hl
 pop af
 pop hl
 ret
 ret
print.a:
 ld a,(hl)
 cp 0
 ret z
 call wrt
 inc hl
 jr print.a
 ret
unreach.new:
 ld hl,unreach.m
 call print.a
 pop hl
 ld (hexval),hl
 call showhex
 db 18h,0feh
unreach.m:
 db "unreach"
 db 0
 ret
;end of include z_debug
;end of include z_sp
;include z_vdp
;https://www.msx.org/wiki/VDP_Status_Registers
;st 0 bit 7
;read 1
;https://www.msx.org/wiki/VDP_Mode_Registers
;ctrl 1 bit 5 set 0
;include th
susint:
 ld a,(RG1SAV)
 res 5,a
 ld b,A
 ld c,1
 jp WRTVDP
 ret
rstint:
 ld a,(RG1SAV)
 set 5,a
 ld b,A
 ld c,1
 jp WRTVDP
 ret
inted:
 call RDVDP
 bit 7,a
 ret
doint:
 call inted
 jr z, norst
 ld hl,timecnt
 inc (hl)
 call h.tntimi
norst:
;call rstint
 ret
setInterval:
 ld (h.tntimi+1),hl
 ret
clearInterval:
 ld hl, int.nop
 jp setInterval
 ret
int.nop:
 ret
 ret
screen1:
 ld a,1
 call CHGMOD
 ld a,(RG1SAV)
 set 1,a
 ld b,A
 ld c,1
 call WRTVDP
 ret
screen2:
;ld a,2
;call CHGMOD
 call 72h
 ld a,(RG1SAV)
 set 1,a
 ld b,A
 ld c,1
 call WRTVDP
 ret
;end of include z_vdp
th.ofs.stp equ 256-4
th.ofs.sp equ th.ofs.stp+1
th.ofs.spini equ th.ofs.stp
fld.top equ th.ofs.spini-2
th.st.blank equ 0c9h
th.st.active equ 31h
th.isblank.a:
; h= thread
; z if true
 ld l, th.ofs.stp
 ld a,(hl)
 cp th.st.blank
 ret
th.find.blank:
; h: result  nz: not found
 ld a,(th.new.end)
 ld b,a
 ld a,(th.new.start)
 ld h,a
 ld l,th.ofs.stp
L16.loop:
 ld a,(hl)
 cp th.st.blank
 ret z
 ld a,b
 inc h
 cp h
 jr nz,L16.loop
 inc a; reset z
 ret
th.new:
; nz for alloc fail
 call th.find.blank
 ret nz
; TODO th.ofs.stp
 ld L,th.ofs.stp
 ld (HL),31h
 inc HL
 ld (HL),th.ofs.spini
 ld a,h
 inc HL
 ld (hl),a
 inc HL
 ld (HL),0c9h
 ld l,th.bottom
 ld a,l
 cp l; set z
 ret
 ret
th.init:
 ld a,0+(th.start.h)
L19.loop:
  cp th.count+(th.start.h)
  jp nc, L18.lbend
  push af
  ld h,a
  ld l,0
  call L19.do
  ex (sp),hl
  ld a,h
  pop HL
  ld h,a
  ld l,0
  jp c, L18.lbend
  inc a
 jr L19.loop
L19.do:
; TODO th.ofs.stp
  ld L, th.ofs.stp
  ld (HL),th.st.blank
 or a
 ret
L18.lbend:
; disable timer
 ld HL,0fd9fh
 ld (hl),0c9h
 call susint
 ret
 ret
th.stepall:
 ld a,0+(th.start.h)
L20.loop:
  cp th.count+(th.start.h)
  jp nc, thnx
  push af
  ld h,a
  ld l,0
  call L20.do
  ex (sp),hl
  ld a,h
  pop HL
  ld h,a
  ld l,0
  jp c, thnx
  inc a
 jr L20.loop
L20.do:
;todo th.ofs.stp
  ld (th.cur),hl
  call th.isblank.a
  jr nz,L21.jj
;jr cnd, skip
;jr to
;skip:
 or a
 ret
L21.jj:
  call th.step
; chk reserved kill
  ld hl,0
  ld (th.cur),hl
  ld a,(th.kill.reserve)
  cp 0
  jr nz,L22.jj
;jr cnd, skip
;jr to
;skip:
 or a
 ret
L22.jj:
  ld h,a
  call th.kill.a
  xor a
  ld (th.kill.reserve),a
 or a
 ret
thnx:
 ret
th.kill.a:
; th.term = self kill
; th.kill = kill from either external or internal
; h: th
 ld a,(th.cur+1)
 cp h
 jr z, L23.reserve
  ld l, th.ofs.stp
  ld (hl), th.st.blank
  ret
L23.reserve:
  ld (th.kill.reserve),a
 ret
th.step:
 ld (adrssp+1),sp
 ld HL,(th.cur)
 ld l,th.ofs.stp
;call susint
 jp (hl)
 ret
th.term:
 ld hl,(th.cur)
; TODO th.ofs.stp
 ld L,th.ofs.stp
 ld (hl),th.st.blank
 jp adrssp
 ret
;end of include z_th
;include z_oop
;include z_assert
a.reg.trc:
 dw 0
a.reg.adr:
 dw 0
a.reg.min:
 dw 0
a.reg.val:
 dw 0
a.reg.max:
 dw 0
getpc:
 pop hl
 push hl
 ret
;end of include z_assert
;a2 a1  oldpc oldix lcl1 lcl2
argidx equ 2
; hl=arg  stktp=af
;ex (sp),hl
;ld a,h
;push af
;hl=tg
; stk=val hl=tg
;trace mesg
 call h.unreach
 dw null
Object:
.class equ 250
 ld bc,Object
 push bc
.statusReg equ 248
 ld bc,0
 push bc
.main equ 246
 ld bc,null
 push bc
;  arg2 arg1 retad oldix lcl1 lcl2
isobj.a:
;hl=obj?
;cy=true
 ld a,h
 cp th.start.h
 jr c,notobj
 cp th.end.h
 jr nc,notobj
 scf
 ret
notobj:
 and a
 ret
is.subclass.a:
; hl=Subclass
; de=Superclass
; z:true
L26.top:
 rst dcompr
 ret z
 call get.superclass
 push de
 ld de,null
 rst dcompr
 pop de
 jr nz,L26.top
 rst dcompr
 ret
;end of include z_oop
;include z_sub
;end of include z_sub
;trace mesg
 call h.unreach
 dw Object
Sprite:
; .class equ 250
 ld bc,Sprite
 push bc
; .statusReg equ 248
 ld bc,0
 push bc
; .main equ 246
 ld bc,0
 push bc
.x equ 244
 ld bc,100
 push bc
.y equ 242
 ld bc,100
 push bc
.p equ 240
 ld bc,0
 push bc
.c equ 238
 ld bc,2
 push bc
; HL -> A
spr.putslp:
 ld hl, 1b00h
 call SETWRT
 ld a, (spr.puts.b)
 ld b, th.count
L27.sprl:
  ld (this),a
  call spr.put1
 ld a,(this)
  ld c,a
  ld a,(spr.puts.s)
  add a,c
  cp th.end.h
  jr c,L27.nrst
   sub th.count
L27.nrst:
 djnz L27.sprl
 ld a,208
  out (98h),a
 ret
;end of include z_spr
;include z_bool
true equ -1
false equ 0
hleqde:
 and a
 sbc hl,de
  jr nz,L30.tru
;jr cnd, skip
;jr to
;skip:
  ld hl,true
  ret
L30.tru:
 ld hl,false
 ret
hlnede:
 and a
 sbc hl,de
  jr z,L31.tru
;jr cnd, skip
;jr to
;skip:
  ld hl,true
  ret
L31.tru:
 ld hl,false
 ret
hlgtde:
 and a
 sbc hl,de
  jr nz,L32.tru
;jr cnd, skip
;jr to
;skip:
 ld hl,false
 ret
L32.tru:
 bit 7,h
  jr nz,L33.tru
;jr cnd, skip
;jr to
;skip:
  ld hl,true
  ret
L33.tru:
 ld hl,false
 ret
hlltde:
 and a
 sbc hl,de
 bit 7,h
  jr z,L34.tru
;jr cnd, skip
;jr to
;skip:
  ld hl,true
  ret
L34.tru:
 ld hl,false
 ret
hlgede:
 and a
 sbc hl,de
  jr nz,L35.tru
;jr cnd, skip
;jr to
;skip:
  ld hl,true
  ret
L35.tru:
 bit 7,h
  jr nz,L36.tru
;jr cnd, skip
;jr to
;skip:
  ld hl,true
  ret
L36.tru:
 ld hl,false
 ret
hllede:
 and a
 sbc hl,de
  jr nz,L37.tru
;jr cnd, skip
;jr to
;skip:
  ld hl,true
  ret
L37.tru:
 bit 7,h
  jr z,L38.tru
;jr cnd, skip
;jr to
;skip:
  ld hl,true
  ret
L38.tru:
 ld hl,false
 ret
ziffalse:
 push af
 call L39.ziffalse.a
  ex (sp),hl
  ld a,h
  pop HL
 ret
L39.ziffalse.a:
 ld a,0
 cp h
 ret nz
 cp l
 ret
; hl&=de
; hl|=de
nothl:
 call ziffalse
 jp z,L41.fls
  ld hl, false
  ret
L41.fls:
  ld hl, true
 ret
;end of include z_bool
;include z_key
keyall:
;show hl
 ld hl,keymat1
 ld de,keymat2
 ld bc,13
 ldir
 ld a,(keyuse)
 and a
 ret z
 ld a,0
 ld hl,keymat1
L42.lp:
 push af
 call SNSMAT.a
 xor 255
 ld (hl),a
 pop af
 inc hl
 inc a
 cp 11
 jr c,L42.lp
 ld a,1
 call snstk.a
 ld (hl),d
 inc hl
 ld a,2
 call snstk.a
 ld (hl),d
 ret
snstk.a:
 push hl
  ld e,a
  push de
   call 0d5h
  pop de
  ld c,a
  ld b,0
  ld hl,trig2mat
  add hl,bc
  ld d,(hl)
  ld a,e
  push de
   call 0d8h
  pop de
  cp 0
  jr z,L43.skp1
  set 0,d
L43.skp1:
  ld a,e
  inc a
  inc a
  push de
   call 0d8h
  pop de
  cp 0
  jr z,L43.skp2
  set 1,d
L43.skp2:
 pop hl
 ret
getkey.a:
 ex de,hl
 ld hl,keymat1
 call chkmat
 ld hl,0
 ret z
 ld hl,keymat2
 call chkmat
 ld hl,1
 ret z
 inc hl
 ret
chkmat:
 push de
 ld a,d
 ld d,0
 add hl,de
 and (hl)
 pop de
 ret
getkey:
 push af
 call getkey.a
 pop af
 ret
stickX.a:
; a :stickid
; hl:  vec norm
 cp 0
 jr nz,L44.nx1
  ld a,(keymat1+8)
  bit 7,a
  ret nz
  bit 4,a
  jp nz,neghl
  ld hl,0
  ret
L44.nx1:
 cp 1
 jr nz,L44.nx2
  ld a,(keymat1+11)
  bit 7,a
  ret nz
  bit 4,a
  jp nz,neghl
  ld hl,0
  ret
L44.nx2:
 cp 2
 jr nz,L44.nx3
  ld a,(keymat1+12)
  bit 7,a
  ret nz
  bit 4,a
  jp nz,neghl
  ld hl,0
  ret
L44.nx3:
; w 5-b4  a 2-b6  s 5-b0  d 3-b1
  ld a,(keymat1+3);d
  bit 1,a
  ret nz
  ld a,(keymat1+2);a
  bit 6,a
  jp nz,neghl
  ld hl,0
 ret
stickY.a:
; a :stickid
; hl:  vec norm
 cp 0
 jr nz,L45.nx1
  ld a,(keymat1+8)
  bit 6,a
  ret nz
  bit 5,a
  jp nz,neghl
  ld hl,0
  ret
L45.nx1:
 cp 1
 jr nz,L45.nx2
  ld a,(keymat1+11)
  bit 6,a
  ret nz
  bit 5,a
  jp nz,neghl
  ld hl,0
  ret
L45.nx2:
 cp 2
 jr nz,L45.nx3
  ld a,(keymat1+12)
  bit 6,a
  ret nz
  bit 5,a
  jp nz,neghl
  ld hl,0
  ret
L45.nx3:
; w 5-b4  a 2-b6  s 5-b0  d 3-b1
  ld a,(keymat1+5);s
  bit 0,a
  ret nz
  bit 4,a ; w
  jp nz,neghl
  ld hl,0
 ret
;end of include z_key
;include z_mzo
;range 0-20
MZO.main:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
L46.lbexit:
 ld sp,ix
 pop ix
 ret
MZO.init:
 pop bc
 pop hl
 ld (MZO.init.ch),hl
 pop hl
 ld (MZO.init.mp),hl
 push bc
;"static all";
;$len[ch]=20160/2;
 ld hl,10080; const val
 push hl
 ld hl,(MZO.init.ch)
 add hl,hl
 ld de,MZOgbl_len
 add hl,de
 pop de
 ld (hl),e
 inc hl
 ld (hl),d
;$mcount[ch]=0;
 ld hl,0; const val
 push hl
 ld hl,(MZO.init.ch)
 add hl,hl
 ld de,MZOgbl_mcount
 add hl,de
 pop de
 ld (hl),e
 inc hl
 ld (hl),d
;$tempoc[ch]=336;
 ld hl,336; const val
 push hl
 ld hl,(MZO.init.ch)
 add hl,hl
 ld de,MZOgbl_tempoc
 add hl,de
 pop de
 ld (hl),e
 inc hl
 ld (hl),d
;$mute[ch]=0;
 ld hl,0; const val
 push hl
 ld hl,(MZO.init.ch)
 add hl,hl
 ld de,MZOgbl_mute
 add hl,de
 pop de
 ld (hl),e
 inc hl
 ld (hl),d
;$mpoint[ch]=mp;
 ld hl,(MZO.init.mp)
 push hl
 ld hl,(MZO.init.ch)
 add hl,hl
 ld de,MZOgbl_mpoint
 add hl,de
 pop de
 ld (hl),e
 inc hl
 ld (hl),d
L47.lbexit:
 ret
MZO.stop:
 pop bc
 pop hl
 ld (MZO.stop.ch),hl
 push bc
;"static all";
;$mpoint[ch]=0;
 ld hl,0; const val
 push hl
 ld hl,(MZO.stop.ch)
 add hl,hl
 ld de,MZOgbl_mpoint
 add hl,de
 pop de
 ld (hl),e
 inc hl
 ld (hl),d
;var chn=clamp(ch,0,2)
 ld hl,2; const val
 push hl
 ld hl,0; const val
 push hl
 ld hl,(MZO.stop.ch)
 pop bc
 pop de
 call clamp
 ld (MZO.stop.chn),hl
;if !$mute[ch]
 ld hl,(MZO.stop.ch)
 add hl,hl
 ld de,MZOgbl_mute; const val
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 call nothl
;then
 call ziffalse
 jp z,L48.lb4
;sound_vol(chn,0);
 ld hl,0; const val
 ld e,l
 push de
 ld hl,(MZO.stop.chn)
 ld a,l
 pop de
 add a,8
 call WRTPSG
 ld a,(this)
L48.lb4:
L48.lbexit:
 ret
MZO.step:
 pop bc
 pop hl
 ld (MZO.step.ch),hl
 push bc
;"static all";
;var chn=clamp(ch,0,2)
 ld hl,2; const val
 push hl
 ld hl,0; const val
 push hl
 ld hl,(MZO.step.ch)
 pop bc
 pop de
 call clamp
 ld (MZO.step.chn),hl
;var mpoint=$mpoint[ch]
 ld hl,(MZO.step.ch)
 add hl,hl
 ld de,MZOgbl_mpoint; const val
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 ld (MZO.step.mpoint),hl
;if !mpoint
 ld hl,(MZO.step.mpoint)
 call nothl
;then
 call ziffalse
 jp z,L49.lb5
;return return;
 jp L49.lbexit
L49.lb5:
;var mcount=$mcount[ch]
 ld hl,(MZO.step.ch)
 add hl,hl
 ld de,MZOgbl_mcount; const val
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 ld (MZO.step.mcount),hl
;var tempoc=$tempoc[ch]
 ld hl,(MZO.step.ch)
 add hl,hl
 ld de,MZOgbl_tempoc; const val
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 ld (MZO.step.tempoc),hl
;var len=$len[ch]
 ld hl,(MZO.step.ch)
 add hl,hl
 ld de,MZOgbl_len; const val
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 ld (MZO.step.len),hl
;var v=$v [ch]
 ld hl,(MZO.step.ch)
 add hl,hl
 ld de,MZOgbl_v; const val
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 ld (MZO.step.v),hl
;var cmd
;if !$mute[ch]
 ld hl,(MZO.step.ch)
 add hl,hl
 ld de,MZOgbl_mute; const val
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 call nothl
;then
 call ziffalse
 jp z,L49.lb6
;sound_vol(chn,v);
 ld hl,(MZO.step.v)
 ld e,l
 push de
 ld hl,(MZO.step.chn)
 ld a,l
 pop de
 add a,8
 call WRTPSG
 ld a,(this)
L49.lb6:
;mcount-=tempoc;
 ld hl,(MZO.step.mcount)
 ld de,(MZO.step.tempoc)
 and a
 sbc hl,de
 ld (MZO.step.mcount),hl
;if v>0
 ld hl,0; const val
 push hl
 ld hl,(MZO.step.v)
 pop de
 call hlgtde
;then
 call ziffalse
 jp z,L49.lb7
;v--;
 ld hl,(MZO.step.v)
 dec hl
 ld (MZO.step.v),hl
L49.lb7:
L49.lb8:
;while mcount>=-tempoc && mcount<=0
 ld hl,(MZO.step.tempoc)
 call neghl
 push hl
 ld hl,(MZO.step.mcount)
 pop de
 call hlgede
 call ziffalse
 jp z,L49.lb10
 ld hl,0; const val
 push hl
 ld hl,(MZO.step.mcount)
 pop de
 call hllede
L49.lb10:
 call ziffalse
 jp z,L49.lb9
;cmd=peek(mpoint);
 ld hl,(MZO.step.mpoint)
 ld l,(hl)
 ld h,0
 ld (MZO.step.cmd),hl
;if cmd>=0 && cmd<96
 ld hl,0; const val
 push hl
 ld hl,(MZO.step.cmd)
 pop de
 call hlgede
 call ziffalse
 jp z,L49.lb12
 ld hl,96; const val
 push hl
 ld hl,(MZO.step.cmd)
 pop de
 call hlltde
L49.lb12:
;then
 call ziffalse
 jp z,L49.lb11
;if !$mute[ch]
 ld hl,(MZO.step.ch)
 add hl,hl
 ld de,MZOgbl_mute; const val
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 call nothl
;then
 call ziffalse
 jp z,L49.lb13
;sound_scale(chn,cmd);
 ld hl,(MZO.step.cmd)
 push hl
 ld hl,(MZO.step.chn)
 ld a,l
 pop hl
 call mus.scale.a
 ld a,(this)
L49.lb13:
;v=12;
 ld hl,12; const val
 ld (MZO.step.v),hl
;mpoint++;
 ld hl,(MZO.step.mpoint)
 inc hl
 ld (MZO.step.mpoint),hl
;if peek(mpoint)==123
 ld hl,123; const val
 push hl
 ld hl,(MZO.step.mpoint)
 ld l,(hl)
 ld h,0
 pop de
 call hleqde
;then
 call ziffalse
 jp z,L49.lb15
;mpoint++;
 ld hl,(MZO.step.mpoint)
 inc hl
 ld (MZO.step.mpoint),hl
;mcount+=peekw(mpoint);
 ld hl,(MZO.step.mpoint)
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 push hl
 ld hl,(MZO.step.mcount)
 pop de
 add hl, de
 ld (MZO.step.mcount),hl
;mpoint+=2;
 ld hl,(MZO.step.mpoint)
 ld de,2; const val
 add hl, de
 ld (MZO.step.mpoint),hl
 jp L49.lb14
L49.lb15:;else
;mcount+=len;
 ld hl,(MZO.step.mcount)
 ld de,(MZO.step.len)
 add hl, de
 ld (MZO.step.mcount),hl
L49.lb14:
 jp L49.lb9
L49.lb11:
;switch cmd
 ld hl,(MZO.step.cmd)
 ld de,99; const val
 rst dcompr
 jp z,L49.lb160
 ld de,124; const val
 rst dcompr
 jp z,L49.lb161
 ld de,104; const val
 rst dcompr
 jp z,L49.lb162
 ld de,255; const val
 rst dcompr
 jp z,L49.lb163
 ld de,100; const val
 rst dcompr
 jp z,L49.lb164
 ld de,101; const val
 rst dcompr
 jp z,L49.lb165
 ld de,102; const val
 rst dcompr
 jp z,L49.lb166
 ld de,103; const val
 rst dcompr
 jp z,L49.lb167
 ld de,107; const val
 rst dcompr
 jp z,L49.lb168
 ld de,110; const val
 rst dcompr
 jp z,L49.lb169
 ld de,115; const val
 rst dcompr
 jp z,L49.lb1610
 ld de,116; const val
 rst dcompr
 jp z,L49.lb1611
 ld de,118; const val
 rst dcompr
 jp z,L49.lb1612
 ld de,120; const val
 rst dcompr
 jp z,L49.lb1613
 ld de,122; const val
 rst dcompr
 jp z,L49.lb1614
 ld a,(this)
 jp L49.lb16def
L49.lb160:
 ld a,(this)
;case 99
;v=0;
 ld hl,0; const val
 ld (MZO.step.v),hl
;mpoint++;
 ld hl,(MZO.step.mpoint)
 inc hl
 ld (MZO.step.mpoint),hl
;if peek(mpoint)==123
 ld hl,123; const val
 push hl
 ld hl,(MZO.step.mpoint)
 ld l,(hl)
 ld h,0
 pop de
 call hleqde
;then
 call ziffalse
 jp z,L49.lb18
;mpoint++;
 ld hl,(MZO.step.mpoint)
 inc hl
 ld (MZO.step.mpoint),hl
;mcount+=peekw(mpoint);
 ld hl,(MZO.step.mpoint)
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 push hl
 ld hl,(MZO.step.mcount)
 pop de
 add hl, de
 ld (MZO.step.mcount),hl
;mpoint+=2;
 ld hl,(MZO.step.mpoint)
 ld de,2; const val
 add hl, de
 ld (MZO.step.mpoint),hl
 jp L49.lb17
L49.lb18:;else
;mcount+=len;
 ld hl,(MZO.step.mcount)
 ld de,(MZO.step.len)
 add hl, de
 ld (MZO.step.mcount),hl
L49.lb17:
 jp L49.lb16brk
L49.lb161:
 ld a,(this)
;case 124
;v=0;
 ld hl,0; const val
 ld (MZO.step.v),hl
;mpoint++;
 ld hl,(MZO.step.mpoint)
 inc hl
 ld (MZO.step.mpoint),hl
 jp L49.lb16brk
L49.lb162:
 ld a,(this)
;case 104
;mpoint++;
 ld hl,(MZO.step.mpoint)
 inc hl
 ld (MZO.step.mpoint),hl
;var ofs=peekw(mpoint)
 ld hl,(MZO.step.mpoint)
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 ld (MZO.step.ofs),hl
;mpoint--;
 ld hl,(MZO.step.mpoint)
 dec hl
 ld (MZO.step.mpoint),hl
;mpoint+=ofs-65536;
 ld hl,0; const val
 push hl
 ld hl,(MZO.step.ofs)
 pop de
 and a
 sbc hl,de
 push hl
 ld hl,(MZO.step.mpoint)
 pop de
 add hl, de
 ld (MZO.step.mpoint),hl
 jp L49.lb16brk
L49.lb163:
 ld a,(this)
;case 255
;stop(ch);
 ld hl,(MZO.step.ch)
 push hl
 call MZO.stop
 ld a,(this)
;mpoint=0;
 ld hl,0; const val
 ld (MZO.step.mpoint),hl
;mcount=1;
 ld hl,1; const val
 ld (MZO.step.mcount),hl
 jp L49.lb16brk
L49.lb164:
 ld a,(this)
;case 100
;mpoint+=2;
 ld hl,(MZO.step.mpoint)
 ld de,2; const val
 add hl, de
 ld (MZO.step.mpoint),hl
 jp L49.lb16brk
L49.lb165:
 ld a,(this)
;case 101
;mpoint+=2;
 ld hl,(MZO.step.mpoint)
 ld de,2; const val
 add hl, de
 ld (MZO.step.mpoint),hl
 jp L49.lb16brk
 jp L49.lb16brk
L49.lb166:
 ld a,(this)
;case 102
;mpoint+=2;
 ld hl,(MZO.step.mpoint)
 ld de,2; const val
 add hl, de
 ld (MZO.step.mpoint),hl
 jp L49.lb16brk
L49.lb167:
 ld a,(this)
;case 103
;tempoc=peekw(mpoint)*168/60;
 ld hl,(MZO.step.mpoint)
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 ld de,168; const val
 call mul.a
 ld a,(this)
 ld de,60; const val
 call div.a
 ld a,(this)
 ld (MZO.step.tempoc),hl
;mpoint+=3;
 ld hl,(MZO.step.mpoint)
 ld de,3; const val
 add hl, de
 ld (MZO.step.mpoint),hl
 jp L49.lb16brk
L49.lb168:
 ld a,(this)
;case 107
;mpoint+=2;
 ld hl,(MZO.step.mpoint)
 ld de,2; const val
 add hl, de
 ld (MZO.step.mpoint),hl
 jp L49.lb16brk
L49.lb169:
 ld a,(this)
;case 110
;mpoint+=2;
 ld hl,(MZO.step.mpoint)
 ld de,2; const val
 add hl, de
 ld (MZO.step.mpoint),hl
 jp L49.lb16brk
L49.lb1610:
 ld a,(this)
;case 115
;mpoint+=4;
 ld hl,(MZO.step.mpoint)
 ld de,4; const val
 add hl, de
 ld (MZO.step.mpoint),hl
 jp L49.lb16brk
L49.lb1611:
 ld a,(this)
;case 116
;mpoint+=2;
 ld hl,(MZO.step.mpoint)
 ld de,2; const val
 add hl, de
 ld (MZO.step.mpoint),hl
 jp L49.lb16brk
L49.lb1612:
 ld a,(this)
;case 118
;mpoint+=2;
 ld hl,(MZO.step.mpoint)
 ld de,2; const val
 add hl, de
 ld (MZO.step.mpoint),hl
 jp L49.lb16brk
L49.lb1613:
 ld a,(this)
;case 120
;mpoint+=2;
 ld hl,(MZO.step.mpoint)
 ld de,2; const val
 add hl, de
 ld (MZO.step.mpoint),hl
 jp L49.lb16brk
L49.lb1614:
 ld a,(this)
;case 122
;mpoint++;
 ld hl,(MZO.step.mpoint)
 inc hl
 ld (MZO.step.mpoint),hl
;len=peekw(mpoint);
 ld hl,(MZO.step.mpoint)
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 ld (MZO.step.len),hl
;mpoint+=2;
 ld hl,(MZO.step.mpoint)
 ld de,2; const val
 add hl, de
 ld (MZO.step.mpoint),hl
 jp L49.lb16brk
L49.lb16def:
;locate(0,6);
 ld hl,6; const val
 push hl
 ld hl,0; const val
 pop de
 call locate
;printf ("Inv %d %x" ,cmd, mpoint);
 ld hl,L50.st
 jp L50.nx
L50.st: db 73, 110, 118, 32
 db 0
L50.nx:
 call print.a
 ld a,(this)
 ld hl,(MZO.step.cmd)
 call printi.a
 ld a,(this)
 ld hl,L51.st
 jp L51.nx
L51.st: db 32
 db 0
L51.nx:
 call print.a
 ld a,(this)
 ld hl,(MZO.step.mpoint)
 ld (hexval),hl
 call showhex
 ld a,(this)
;stop(ch);
 ld hl,(MZO.step.ch)
 push hl
 call MZO.stop
 ld a,(this)
;mpoint=0;
 ld hl,0; const val
 ld (MZO.step.mpoint),hl
;mcount=1;
 ld hl,1; const val
 ld (MZO.step.mcount),hl
 jp L49.lb16brk
L49.lb16brk:
 jp L49.lb8
L49.lb9:
;$mpoint[ch]=mpoint;
 ld hl,(MZO.step.mpoint)
 push hl
 ld hl,(MZO.step.ch)
 add hl,hl
 ld de,MZOgbl_mpoint
 add hl,de
 pop de
 ld (hl),e
 inc hl
 ld (hl),d
;$mcount[ch]=mcount;
 ld hl,(MZO.step.mcount)
 push hl
 ld hl,(MZO.step.ch)
 add hl,hl
 ld de,MZOgbl_mcount
 add hl,de
 pop de
 ld (hl),e
 inc hl
 ld (hl),d
;$tempoc[ch]=tempoc;
 ld hl,(MZO.step.tempoc)
 push hl
 ld hl,(MZO.step.ch)
 add hl,hl
 ld de,MZOgbl_tempoc
 add hl,de
 pop de
 ld (hl),e
 inc hl
 ld (hl),d
;$len[ch]=len;
 ld hl,(MZO.step.len)
 push hl
 ld hl,(MZO.step.ch)
 add hl,hl
 ld de,MZOgbl_len
 add hl,de
 pop de
 ld (hl),e
 inc hl
 ld (hl),d
;$v [ch]=v;
 ld hl,(MZO.step.v)
 push hl
 ld hl,(MZO.step.ch)
 add hl,hl
 ld de,MZOgbl_v
 add hl,de
 pop de
 ld (hl),e
 inc hl
 ld (hl),d
L49.lbexit:
 ret
MZO.initBGM:
 pop bc
 pop hl
 ld (MZO.initBGM.mpoint),hl
 push bc
;"static all";
;mpoint+=4;
 ld hl,(MZO.initBGM.mpoint)
 ld de,4; const val
 add hl, de
 ld (MZO.initBGM.mpoint),hl
;mpoint++;
 ld hl,(MZO.initBGM.mpoint)
 inc hl
 ld (MZO.initBGM.mpoint),hl
;var size
;size=peekw(mpoint);
 ld hl,(MZO.initBGM.mpoint)
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 ld (MZO.initBGM.size),hl
;mpoint+=4;
 ld hl,(MZO.initBGM.mpoint)
 ld de,4; const val
 add hl, de
 ld (MZO.initBGM.mpoint),hl
;init(0,mpoint);
 ld hl,(MZO.initBGM.mpoint)
 push hl
 ld hl,0; const val
 push hl
 call MZO.init
 ld a,(this)
;mpoint+=size;
 ld hl,(MZO.initBGM.mpoint)
 ld de,(MZO.initBGM.size)
 add hl, de
 ld (MZO.initBGM.mpoint),hl
;size=peekw(mpoint);
 ld hl,(MZO.initBGM.mpoint)
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 ld (MZO.initBGM.size),hl
;mpoint+=4;
 ld hl,(MZO.initBGM.mpoint)
 ld de,4; const val
 add hl, de
 ld (MZO.initBGM.mpoint),hl
;init(1,mpoint);
 ld hl,(MZO.initBGM.mpoint)
 push hl
 ld hl,1; const val
 push hl
 call MZO.init
 ld a,(this)
;mpoint+=size;
 ld hl,(MZO.initBGM.mpoint)
 ld de,(MZO.initBGM.size)
 add hl, de
 ld (MZO.initBGM.mpoint),hl
;size=peekw(mpoint);
 ld hl,(MZO.initBGM.mpoint)
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 ld (MZO.initBGM.size),hl
;mpoint+=4;
 ld hl,(MZO.initBGM.mpoint)
 ld de,4; const val
 add hl, de
 ld (MZO.initBGM.mpoint),hl
;init(2,mpoint);
 ld hl,(MZO.initBGM.mpoint)
 push hl
 ld hl,2; const val
 push hl
 call MZO.init
 ld a,(this)
;mpoint+=size;
 ld hl,(MZO.initBGM.mpoint)
 ld de,(MZO.initBGM.size)
 add hl, de
 ld (MZO.initBGM.mpoint),hl
L52.lbexit:
 ret
MZO.initSE:
 pop bc
 pop hl
 ld (MZO.initSE.mpoint),hl
 push bc
;"static all";
;if $mpoint [3] &&    $mpoint [3]<mpoint
 ld hl,3; const val
 add hl,hl
 ld de,MZOgbl_mpoint; const val
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 call ziffalse
 jp z,L53.lb20
 ld hl,(MZO.initSE.mpoint)
 push hl
 ld hl,3; const val
 add hl,hl
 ld de,MZOgbl_mpoint; const val
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 pop de
 call hlltde
L53.lb20:
;then
 call ziffalse
 jp z,L53.lb19
;return return;
 jp L53.lbexit
L53.lb19:
;mpoint+=4;
 ld hl,(MZO.initSE.mpoint)
 ld de,4; const val
 add hl, de
 ld (MZO.initSE.mpoint),hl
;mpoint++;
 ld hl,(MZO.initSE.mpoint)
 inc hl
 ld (MZO.initSE.mpoint),hl
;var size=peekw(mpoint)
 ld hl,(MZO.initSE.mpoint)
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 ld (MZO.initSE.size),hl
;mpoint+=4;
 ld hl,(MZO.initSE.mpoint)
 ld de,4; const val
 add hl, de
 ld (MZO.initSE.mpoint),hl
;init(3,mpoint);
 ld hl,(MZO.initSE.mpoint)
 push hl
 ld hl,3; const val
 push hl
 call MZO.init
 ld a,(this)
L53.lbexit:
 ret
MZO.stopBGM:
 pop bc
 push bc
;"static all";
;for var i=0;
;var i=0
 ld hl,0; const val
 ld (MZO.stopBGM.i),hl
L54.lb21:
;while i<3
 ld hl,3; const val
 push hl
 ld hl,(MZO.stopBGM.i)
 pop de
 call hlltde
 call ziffalse
 jp z,L54.lb22
;stop(i);
 ld hl,(MZO.stopBGM.i)
 push hl
 call MZO.stop
 ld a,(this)
L54.lb23:
;next i++
 ld hl,(MZO.stopBGM.i)
 inc hl
 ld (MZO.stopBGM.i),hl
 jp L54.lb21
L54.lb22:
L54.lbexit:
 ret
MZO.stepAll:
 pop bc
 push bc
;"static all";
;for var i=0;
;var i=0
 ld hl,0; const val
 ld (MZO.stepAll.i),hl
L55.lb24:
;while i<4
 ld hl,4; const val
 push hl
 ld hl,(MZO.stepAll.i)
 pop de
 call hlltde
 call ziffalse
 jp z,L55.lb25
;step(i);
 ld hl,(MZO.stepAll.i)
 push hl
 call MZO.step
 ld a,(this)
L55.lb26:
;next i++
 ld hl,(MZO.stepAll.i)
 inc hl
 ld (MZO.stepAll.i),hl
 jp L55.lb24
L55.lb25:
;$mute[2]=$mpoint [3];
 ld hl,3; const val
 add hl,hl
 ld de,MZOgbl_mpoint; const val
 add hl,de
 ld e,(hl)
 inc hl
 ld d,(hl)
 ex de,hl
 push hl
 ld hl,2
 add hl,hl
 ld de,MZOgbl_mute
 add hl,de
 pop de
 ld (hl),e
 inc hl
 ld (hl),d
L55.lbexit:
 ret
;end of include z_mzo
;.onUpdate equ .c-2
;.update equ .onUpdate-2
;.screenOut equ .update-2
;.die equ .screenOut-2
;.updateEx equ .die-2
;keep'em. used in FldIdx
;fld .class,Class
;fld .statusReg,0
; a=this
; skip blank
; TODO th.ofs.stp
; skip hl==this
; skip object not instance of *Class*
onExitFrame:
 ld hl,(gbl_frameCount)
 inc hl
 ld (gbl_frameCount),hl
 jp spr.puts
 ret
;ld a,0
;call MZOCmd
;call mus.ini
;call clearInterval
;end of include z_tnu
;include z_map
map.adr:
; hl=chipx
; de=chipy
 sla e
 rl d
 sla e
 rl d
 sla e
 rl d
 sla e
 rl d
 sla e
 rl d
 add hl,de
 ld de,1800h
 add hl,de
 ret
map.set.a:
;  a=data
 call map.adr
 call 4dh
 ret
map.get.a:
 call map.adr
 call 4ah
 ret
map.adrat.a:
; hl=spr_x
; de=spr_y
 ld bc,(gbl_offsetX)
 and a
 sbc hl,bc
; HL -> A
 srl h
 rr l
 LD A,L
 srl a
 srl a
 srl a
 push af
 ex de,hl
 ld bc,(gbl_offsetY)
 and a
 sbc hl,bc
; HL -> A
 srl h
 rr l
 LD A,L
 srl a
 srl a
 srl a
 ld d,0
 ld e,a
 pop hl
 ld l,h
 ld h,0
 call map.adr
 ret
map.getat.a:
 call map.adrat.a
 call 4ah
 ret
map.setat.a:
; a=data
 push af
 call map.adrat.a
 pop af
 call 4dh
 ret
locate:
; hl=chipx
; de=chipy
 call map.adr
 ld (cursor),hl
 ret
;end of include z_map
;include z_dac
;jp main
DECSUB equ 268CH;DAC ← DAC-ARG
DECADD equ 269AH;DAC ← DAC+ARG
DECNRM equ 26FAH;DAC を正規化する (*1)
DECROU equ 273CH;DAC を四捨五入する
DECMUL equ 27E6H;DAC ← DAC*DAC
DECDIV equ 289FH;DAC ← DAC/DAC
MAF equ 2C4DH;ARG ← DAC
MAM equ 2C50H;ARG ← [HL]
MOV8DH equ 2C53H;[DE] ← [HL]
MFA equ 2C59H;DAC ← ARG
MFM equ 2C5CH;[HL] ← DAC
MMF equ 2C67H;[HL] ← DAC
MOV8HD equ 2C6AH;[HL] ← [DE]
XTF equ 2C6FH;[SP] ←→ DAC
PHA equ 2CC7H;ARG → [SP]
PHF equ 2CCCH;DAC → [SP]
PPA equ 2CDCH;[SP] → ARG
PPF equ 2CE1H;[SP] → DAC
PUSHF equ 2EB1H;DAC → [SP]
MOVFM equ 2EBEH;DAC ← [HL]
MOVFR equ 2EC1H;DAC ← (CBED)
MOVRF equ 2ECCH;(CBED) ← DAC
MOVRMI equ 2ED6H;(CBDE) ← [HL]
MOVRM equ 2EDFH;(BCDE) ← [HL]
MOVMF equ 2EE8H;[HL] ← DAC
MOVE equ 2EEBH;[HL] ← [DE]
VMOVAM equ 2EEFH;ARG ← [HL]
MOVVFM equ 2EF2H;[DE] ← [HL]
VMOVE equ 2EF3H;[HL] ← [DE]
VMOVFA equ 2F05H;DAC ← ARG
VMOVFM equ 2F08H;DAC ← [HL]
VMOVAF equ 2F0DH;ARG ← DAC
VMOVMF equ 2F10H;[HL] ← DAC
VALTYP equ 0F663H;1
DAC equ 0F7F6H;16
ARG equ 0F847H;16
FOUT equ 3425H
PUFOUT equ 3426H
int2dac:
 push af
 ld a,2
 ld (VALTYP),a
 ld (DAC+2),HL
 pop af
 ret
;===your code
L57.main:
 ld hl,12345
 call int2dac
 ld hl,L57.str
 call FOUT
 ld b,10
 inc b
 djnz L58.lb
 jp L57.nxt
L58.lb:
  push bc
  call L58.s
  pop bc
  jp c,L57.nxt
 djnz L58.lb
 jp L57.nxt
L58.s:
 ld a,(hl)
 cp 0
  jr nz,L59.jj
;jr cnd, skip
;jr to
;skip:
 scf
 ret
L59.jj:
 call wrt
 inc hl
 or a
 ret
L57.nxt:
 ret
L57.str:
myfout.a:
 xor a
 ld (strbuf.i+1),a
 bit 7,h
 jr z, L60.posi
L60.nega:
 push de
 call neghl
 pop de
 ld a, '-'
 ld (strbuf.i),a
 jr L60.loop
L60.posi:
 ld a, space.char
 ld (strbuf.i),a
L60.loop:
 ld de,10
 call udiv.a
;show bc
; bc=q hl=r
 ld a,l
 push bc
 call unshift.sbuf
 pop hl
 add a,'0'
 ld (strbuf.i+1),a
 ld a,h
 or l
 jr nz, L60.loop
 ret
printi.a:
;call int2dac
 call myfout.a
 ld hl,strbuf.i
;ld a,128
;ld b,0
;call FOUT
 call print.a
 ret
; 0123456
; s12345
;       
unshift.sbuf:
 ld hl, strbuf.i+5
 ld de, strbuf.i+6
 ld bc, 5
 lddr
 ret
;end of include z_dac
;include z_mus
mus.scale.a:
; a: 0,1,2 ch
; l: 0-95
 sla a
 sla l
 ld h,0
 ld bc,scltbl
 add hl,bc
 ld e,(hl)
 call WRTPSG
 inc hl
 ld e,(hl)
 inc a
 call WRTPSG
 ret
scltbl:
 dw 0d5dh, 0c9ch, 0be7h, 0b3ch, 0a9bh, 0a02h, 0973h, 08ebh, 086bh, 07f2h, 0780h, 0714h, 06afh, 064eh, 05f4h, 059eh, 054eh, 0501h, 04bah, 0476h, 0436h, 03f9h, 03c0h, 038ah, 0357h, 0327h, 02fah, 02cfh, 02a7h, 0281h, 025dh, 023bh, 021bh, 01fdh, 01e0h, 01c5h, 01ach, 0194h, 017dh, 0168h, 0153h, 0140h, 012eh, 011dh, 010dh, 0feh, 0f0h, 0e3h, 0d6h, 0cah, 0beh, 0b4h, 0aah, 0a0h, 097h, 08fh, 087h, 07fh, 078h, 071h, 06bh, 065h, 05fh, 05ah, 055h, 050h, 04ch, 047h, 043h, 040h, 03ch, 039h, 035h, 032h, 030h, 02dh, 02ah, 028h, 026h, 024h, 022h, 020h, 01eh, 01ch, 01bh, 019h, 018h, 016h, 015h, 014h, 013h, 012h, 011h, 010h, 0fh, 0eh
;end of include z_mus
;!ROM
gbl_se_bgms: 
 db 220, 5, 0, 0, 10, 29, 0, 0, 0, 124, 101, 20, 120, 0, 122, 216
 db 9, 50, 53, 57, 50, 53, 57, 60, 59, 57, 60, 59, 50, 53, 104, 238
 db 255, 255, 255, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4, 0
 db 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4, 0
 db 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4, 0
 db 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4, 0
 db 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255
gbl_se_miss: 
 db 220, 5, 0, 0, 10, 62, 0, 0, 0, 124, 122, 118, 2, 101, 0, 100
 db 40, 24, 99, 35, 33, 31, 29, 28, 26, 24, 24, 99, 35, 33, 31, 29
 db 28, 26, 24, 24, 99, 35, 33, 31, 29, 28, 26, 24, 99, 43, 41, 40
 db 38, 36, 35, 33, 31, 29, 28, 26, 24, 23, 21, 19, 17, 16, 14, 12
 db 11, 9, 7, 5, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255
gbl_se_laserPre: 
 db 220, 5, 0, 0, 10, 53, 0, 0, 0, 124, 122, 118, 2, 101, 0, 100
 db 40, 33, 21, 9, 35, 23, 11, 36, 24, 12, 38, 26, 14, 40, 28, 16
 db 41, 29, 17, 43, 31, 19, 45, 33, 21, 47, 35, 23, 48, 36, 24, 50
 db 38, 26, 52, 40, 28, 53, 41, 29, 55, 43, 31, 255, 255, 255, 4, 0
 db 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4, 0
 db 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4, 0
 db 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4, 0
 db 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4, 0
 db 0, 0, 124, 255, 255, 255
gbl_se_b: 
 db 220, 5, 0, 0, 10, 14, 0, 0, 0, 124, 122, 118, 2, 101, 0, 100
 db 40, 59, 47, 35, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255
gbl_se_a: 
 db 220, 5, 0, 0, 10, 14, 0, 0, 0, 124, 122, 118, 2, 101, 0, 100
 db 40, 57, 45, 33, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255
gbl_se_g: 
 db 220, 5, 0, 0, 10, 14, 0, 0, 0, 124, 122, 118, 2, 101, 0, 100
 db 40, 55, 43, 31, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255
gbl_se_f: 
 db 220, 5, 0, 0, 10, 14, 0, 0, 0, 124, 122, 118, 2, 101, 0, 100
 db 40, 53, 41, 29, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255
gbl_se_laser: 
 db 220, 5, 0, 0, 10, 60, 0, 0, 0, 124, 122, 118, 2, 100, 40, 57
 db 45, 33, 44, 32, 21, 44, 32, 21, 44, 32, 21, 44, 32, 21, 44, 32
 db 21, 44, 32, 21, 44, 32, 21, 44, 32, 21, 44, 32, 21, 44, 32, 21
 db 44, 32, 21, 44, 32, 21, 44, 32, 21, 44, 32, 21, 44, 32, 21, 44
 db 32, 21, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4, 0, 0
 db 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4, 0, 0
 db 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4, 0, 0
 db 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4, 0, 0
 db 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255
gbl_se_iopen: 
 db 220, 5, 0, 0, 10, 29, 0, 0, 0, 124, 120, 0, 122, 216, 9, 101
 db 5, 26, 123, 176, 19, 99, 26, 26, 26, 26, 123, 176, 19, 99, 104, 236
 db 255, 255, 255, 255, 255, 255, 29, 0, 0, 0, 124, 120, 0, 122, 216, 9
 db 101, 5, 14, 123, 176, 19, 99, 14, 14, 14, 14, 123, 176, 19, 99, 104
 db 236, 255, 255, 255, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255, 4, 0, 0, 0, 124, 255, 255, 255, 4
 db 0, 0, 0, 124, 255, 255, 255
;!/ROM
;begin of global variables
;end of global variables
endusr:
;include z_vram
inipat:
 ld de,3800h
 ld hl,spr.pat
 ld bc,end.spr.pat-spr.pat
 call LDIRVM
 ld de,0000h
 ld hl,bg.gen
 ld bc,end.bg.gen-bg.gen
 call LDIRVM
 ld de,0800h
 ld hl,bg.gen
 ld bc,end.bg.gen-bg.gen
 call LDIRVM
 ld de,1000h
 ld hl,bg.gen
 ld bc,end.bg.gen-bg.gen
 call LDIRVM
 ld de,2000h
 ld hl,bg.col
 ld bc,end.bg.col-bg.col
 call LDIRVM
 ld de,2800h
 ld hl,bg.col
 ld bc,end.bg.col-bg.col
 call LDIRVM
 ld de,3000h
 ld hl,bg.col
 ld bc,end.bg.col-bg.col
 call LDIRVM
 ld hl,1800h
 ld a,32
 ld bc,300h
 call filvrm
 ret
;end of include z_vram
spr.pat:
 db 00ch, 00eh, 00fh, 04fh, 03dh, 01dh, 07fh, 01bh, 00ch, 03fh, 07fh, 07fh, 06fh, 00fh, 006h, 00ch
 db 018h, 038h, 0f8h, 0f9h, 0deh, 0dch, 07fh, 06ch, 098h, 0fch, 0feh, 0feh, 0f6h, 0f0h, 060h, 070h
 db 00ch, 00eh, 00fh, 04fh, 03dh, 01dh, 07fh, 01bh, 00ch, 03fh, 07fh, 07fh, 0efh, 0efh, 006h, 006h
 db 018h, 038h, 0f8h, 0f9h, 0deh, 0dch, 07fh, 06ch, 098h, 0fch, 0feh, 0feh, 0d4h, 078h, 0f0h, 000h
 db 018h, 01ch, 01fh, 09fh, 07bh, 03bh, 0feh, 036h, 019h, 03fh, 07fh, 07fh, 02bh, 01eh, 00fh, 000h
 db 030h, 070h, 0f0h, 0f2h, 0bch, 0b8h, 0feh, 0d8h, 030h, 0fch, 0feh, 0feh, 0f7h, 0f7h, 060h, 060h
 db 02ch, 08eh, 00fh, 04bh, 03dh, 011h, 07fh, 01dh, 0cah, 0ffh, 07fh, 03fh, 015h, 01fh, 00eh, 000h
 db 01ch, 039h, 0f8h, 0e9h, 0deh, 0c4h, 07fh, 05ch, 0abh, 0ffh, 0ffh, 0feh, 0ach, 0f8h, 070h, 000h
 db 0b8h, 05eh, 02fh, 017h, 00fh, 003h, 00fh, 01fh, 01fh, 03fh, 01fh, 003h, 00bh, 017h, 02eh, 0dch
 db 000h, 000h, 000h, 000h, 080h, 0f0h, 0c8h, 0c4h, 0e2h, 0ffh, 0ffh, 0fch, 080h, 000h, 000h, 000h
 db 008h, 010h, 030h, 030h, 018h, 00fh, 03fh, 037h, 07bh, 07dh, 03fh, 01fh, 037h, 060h, 070h, 00ch
 db 008h, 004h, 006h, 006h, 00ch, 0f8h, 0feh, 0f6h, 0efh, 0dfh, 0feh, 0fch, 0f6h, 003h, 007h, 018h
 db 000h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 000h, 000h
 db 080h, 0c0h, 0c0h, 0c0h, 0c0h, 0c0h, 0c0h, 0c0h, 0c0h, 0c0h, 0c0h, 0c0h, 0c0h, 0c0h, 080h, 000h
 db 000h, 000h, 000h, 000h, 000h, 001h, 003h, 001h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 080h, 0c0h, 080h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 003h, 00fh, 00fh, 01fh, 01eh, 01eh, 01fh, 00fh, 00fh, 003h, 000h, 000h, 000h
 db 000h, 000h, 000h, 0c0h, 0f0h, 0f0h, 0f8h, 078h, 078h, 0f8h, 0f0h, 0f0h, 0c0h, 000h, 000h, 000h
 db 000h, 000h, 007h, 00fh, 018h, 030h, 030h, 030h, 030h, 030h, 018h, 00fh, 007h, 000h, 000h, 000h
 db 000h, 000h, 0c0h, 0e0h, 030h, 018h, 018h, 018h, 018h, 018h, 030h, 0e0h, 0c0h, 000h, 000h, 000h
 db 000h, 003h, 007h, 00eh, 01ch, 038h, 030h, 030h, 030h, 038h, 01ch, 00eh, 007h, 003h, 000h, 000h
 db 000h, 0e0h, 0f0h, 038h, 01ch, 00eh, 006h, 006h, 006h, 00eh, 01ch, 038h, 0f0h, 0e0h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 003h, 047h, 02fh, 01dh, 01dh, 03fh, 05fh, 01ch, 00fh, 007h, 003h, 004h, 004h, 004h, 000h
 db 000h, 0c0h, 0e2h, 0f4h, 0b8h, 0b8h, 0fch, 0fah, 038h, 0f0h, 0e0h, 0c0h, 020h, 020h, 020h, 000h
 db 080h, 040h, 02fh, 01fh, 03fh, 03bh, 03bh, 03fh, 03fh, 03fh, 03fh, 030h, 01fh, 02fh, 040h, 080h
 db 001h, 002h, 0f4h, 0f8h, 0fch, 0dch, 0dch, 0fch, 0fch, 0fch, 0fch, 00ch, 0f8h, 0f4h, 002h, 001h
 db 000h, 007h, 01fh, 03bh, 03bh, 03fh, 03fh, 038h, 01fh, 00fh, 012h, 0e2h, 042h, 002h, 004h, 00ch
 db 000h, 0e0h, 0f8h, 0dch, 0dch, 0fch, 0fch, 01ch, 0f8h, 0f0h, 048h, 047h, 042h, 040h, 020h, 030h
 db 000h, 007h, 007h, 00fh, 00dh, 00dh, 00fh, 00fh, 00fh, 00ch, 01fh, 03fh, 077h, 067h, 046h, 000h
 db 000h, 0e0h, 0e0h, 0f0h, 0b0h, 0b0h, 0f0h, 0f0h, 0f0h, 030h, 0f8h, 0fch, 0eeh, 0e6h, 062h, 000h
 db 03fh, 03fh, 0edh, 0edh, 0ffh, 0c7h, 07fh, 00fh, 01fh, 03fh, 03eh, 07fh, 07fh, 07fh, 03fh, 00fh
 db 0e0h, 0e0h, 0e0h, 0e0h, 0c0h, 0c0h, 0c0h, 080h, 000h, 000h, 007h, 00fh, 03fh, 0feh, 0fch, 0f0h
 db 000h, 000h, 007h, 00fh, 01fh, 03fh, 07fh, 07fh, 0ffh, 0ffh, 0ffh, 0feh, 0ffh, 07fh, 07eh, 000h
 db 00fh, 0ffh, 0ffh, 0ffh, 0ffh, 0b7h, 0b7h, 0ffh, 0feh, 0feh, 0fch, 000h, 0f0h, 0c0h, 000h, 000h
 db 00fh, 03fh, 07fh, 07bh, 0fbh, 0ffh, 0ffh, 078h, 07fh, 03fh, 03fh, 01ah, 032h, 062h, 07ah, 008h
 db 0f0h, 0fch, 0feh, 0deh, 0dfh, 0ffh, 0ffh, 01eh, 0feh, 0fch, 0fch, 058h, 04ch, 046h, 05eh, 010h
 db 020h, 030h, 03dh, 03fh, 03fh, 01fh, 0dfh, 0fdh, 07dh, 07fh, 07fh, 03fh, 03ch, 01fh, 007h, 003h
 db 004h, 00ch, 0bch, 0fch, 0fch, 0f8h, 0fbh, 0bfh, 0beh, 0feh, 0feh, 0fch, 03ch, 0f8h, 0e0h, 0c0h
 db 001h, 001h, 003h, 003h, 007h, 00fh, 00fh, 01bh, 03bh, 03fh, 03fh, 03fh, 03ch, 01fh, 00fh, 003h
 db 080h, 080h, 0c0h, 0c0h, 0e0h, 0f0h, 0f0h, 0d8h, 0dch, 0fch, 0fch, 0fch, 03ch, 0f8h, 0f0h, 0c0h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
end.spr.pat:
bg.gen:
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 00fh, 00fh, 00fh, 00fh, 00fh, 00fh, 00fh, 00fh
 db 000h, 080h, 080h, 080h, 080h, 080h, 080h, 000h, 000h, 080h, 080h, 080h, 080h, 080h, 080h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 00fh, 0e0h, 0c0h, 083h, 0f0h
 db 000h, 000h, 000h, 0c0h, 0f0h, 007h, 003h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 001h, 001h, 003h, 003h, 005h, 00dh, 00eh, 01eh
 db 0c0h, 0c0h, 0e0h, 0f0h, 0f0h, 007h, 007h, 0d4h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 001h, 007h, 00fh, 0e0h, 0c0h, 080h, 0f0h, 0c0h, 0e0h, 0c0h, 0c0h, 080h, 000h, 000h, 000h, 000h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 080h, 0e0h, 0f0h, 007h, 003h, 000h, 002h, 005h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 0c0h, 0c0h, 0b0h, 090h, 088h, 00dh, 002h, 000h
 db 02ch, 011h, 001h, 023h, 02bh, 048h, 060h, 022h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 080h, 000h, 000h, 000h, 000h, 000h, 038h, 000h, 000h, 000h, 002h, 005h, 00ah, 0c0h, 0c0h, 0c0h
 db 00ah, 015h, 055h, 0aah, 055h, 007h, 003h, 0c1h, 02ah, 0a8h, 055h, 0aah, 054h, 000h, 000h, 000h
 db 001h, 003h, 003h, 003h, 007h, 007h, 007h, 007h, 000h, 000h, 000h, 080h, 041h, 022h, 014h, 008h
 db 028h, 024h, 043h, 083h, 002h, 082h, 040h, 031h, 080h, 0c0h, 080h, 020h, 0c0h, 0a0h, 040h, 090h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 080h, 080h, 080h, 080h, 080h, 080h, 083h, 0c0h
 db 001h, 001h, 0e0h, 0e0h, 0c0h, 0c0h, 001h, 001h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 009h, 00eh, 0e0h, 0e0h, 001h, 01ch, 0c0h, 080h, 000h, 000h, 083h, 0a3h, 030h, 00fh, 0c0h, 000h
 db 00ah, 046h, 085h, 002h, 005h, 003h, 000h, 000h, 0a0h, 058h, 0a8h, 058h, 080h, 01ch, 083h, 001h
 db 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 0c0h, 0c0h, 0c0h, 01fh, 00fh, 00fh, 007h, 003h
 db 001h, 003h, 007h, 007h, 0f0h, 0e0h, 0e0h, 0c0h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
 db 080h, 000h, 000h, 000h, 000h, 080h, 0c0h, 007h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 007h
 db 000h, 000h, 000h, 000h, 000h, 000h, 0f0h, 000h, 001h, 003h, 003h, 003h, 007h, 0c0h, 001h, 0c0h
 db 083h, 0c6h, 031h, 029h, 019h, 0c6h, 083h, 000h, 018h, 038h, 078h, 018h, 018h, 018h, 081h, 000h
 db 083h, 0c6h, 006h, 01ch, 070h, 0c2h, 001h, 000h, 083h, 0c6h, 006h, 03ch, 006h, 0c6h, 083h, 000h
 db 01ch, 03ch, 06ch, 0cch, 001h, 00ch, 00ch, 000h, 001h, 0c0h, 003h, 006h, 006h, 0c6h, 083h, 000h
 db 083h, 0c6h, 0c0h, 003h, 0c6h, 0c6h, 083h, 000h, 001h, 0c6h, 00ch, 01ch, 018h, 038h, 038h, 000h
 db 083h, 0c6h, 0c6h, 083h, 0c6h, 0c6h, 083h, 000h, 083h, 0c6h, 0c6h, 081h, 006h, 004h, 078h, 000h
 db 000h, 030h, 030h, 000h, 000h, 030h, 030h, 000h, 000h, 030h, 030h, 000h, 000h, 030h, 030h, 060h
 db 010h, 030h, 081h, 001h, 081h, 030h, 010h, 000h, 000h, 000h, 083h, 000h, 083h, 000h, 000h, 000h
 db 010h, 018h, 003h, 001h, 003h, 018h, 010h, 000h, 03ch, 066h, 006h, 00ch, 018h, 000h, 018h, 000h
 db 083h, 082h, 00dh, 08ah, 045h, 0cah, 083h, 000h, 01ch, 036h, 036h, 066h, 081h, 0c6h, 0c6h, 000h
 db 003h, 066h, 066h, 083h, 066h, 066h, 003h, 000h, 083h, 019h, 0c6h, 0c0h, 0c0h, 019h, 083h, 000h
 db 003h, 066h, 066h, 066h, 066h, 066h, 003h, 000h, 001h, 066h, 060h, 083h, 060h, 066h, 001h, 000h
 db 001h, 066h, 060h, 083h, 060h, 060h, 0f0h, 000h, 083h, 019h, 0c0h, 031h, 0c6h, 019h, 081h, 000h
 db 0c6h, 0c6h, 0c6h, 001h, 0c6h, 0c6h, 0c6h, 000h, 078h, 030h, 030h, 030h, 030h, 030h, 078h, 000h
 db 0c1h, 00ch, 00ch, 00ch, 0cch, 0cch, 078h, 000h, 019h, 06ch, 078h, 070h, 068h, 06ch, 019h, 000h
 db 0f0h, 060h, 060h, 060h, 060h, 062h, 001h, 000h, 0c6h, 011h, 001h, 029h, 029h, 0c6h, 0c6h, 000h
 db 0c6h, 019h, 019h, 029h, 031h, 031h, 0c6h, 000h, 083h, 0c6h, 0c6h, 0c6h, 0c6h, 0c6h, 083h, 000h
 db 003h, 066h, 066h, 066h, 083h, 060h, 0f0h, 000h, 083h, 0c6h, 0c6h, 0c6h, 009h, 031h, 080h, 000h
 db 003h, 066h, 066h, 066h, 083h, 06ch, 019h, 000h, 083h, 0c6h, 0c0h, 083h, 006h, 0c6h, 083h, 000h
 db 001h, 025h, 018h, 018h, 018h, 018h, 03ch, 000h, 0c6h, 0c6h, 0c6h, 0c6h, 0c6h, 0c6h, 083h, 000h
 db 0c6h, 0c6h, 0c6h, 0c6h, 06ch, 083h, 038h, 000h, 0c6h, 0c6h, 029h, 029h, 001h, 011h, 0c6h, 000h
 db 0c6h, 0c6h, 06ch, 038h, 06ch, 0c6h, 0c6h, 000h, 0c6h, 0c6h, 066h, 03ch, 018h, 018h, 018h, 000h
 db 001h, 0cch, 018h, 030h, 062h, 0c6h, 001h, 000h, 078h, 060h, 060h, 060h, 060h, 060h, 078h, 000h
 db 0c6h, 06ch, 038h, 083h, 030h, 083h, 030h, 000h, 078h, 018h, 018h, 018h, 018h, 018h, 078h, 000h
 db 010h, 038h, 064h, 0c2h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 083h, 000h
 db 060h, 060h, 030h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 078h, 00ch, 083h, 0cch, 081h, 000h
 db 080h, 0c0h, 007h, 0cch, 0cch, 0cch, 007h, 000h, 000h, 000h, 078h, 0cch, 0c0h, 0cch, 078h, 000h
 db 00ch, 00ch, 083h, 0cch, 0cch, 0cch, 074h, 000h, 000h, 000h, 078h, 0cch, 003h, 0c0h, 083h, 000h
 db 010h, 038h, 030h, 003h, 030h, 030h, 030h, 060h, 000h, 000h, 074h, 0cch, 0cch, 083h, 00ch, 078h
 db 0c0h, 0c0h, 007h, 0cch, 0cch, 0cch, 0cch, 000h, 030h, 000h, 070h, 030h, 030h, 030h, 078h, 000h
 db 018h, 000h, 038h, 018h, 018h, 018h, 0d8h, 070h, 060h, 060h, 06ch, 078h, 070h, 078h, 06ch, 000h
 db 070h, 030h, 030h, 030h, 030h, 030h, 078h, 000h, 000h, 000h, 013h, 001h, 029h, 029h, 029h, 000h
 db 000h, 000h, 0b8h, 0cch, 0cch, 0cch, 0cch, 000h, 000h, 000h, 078h, 0cch, 0cch, 0cch, 078h, 000h
 db 000h, 000h, 0b8h, 0cch, 0cch, 007h, 0c0h, 0c0h, 000h, 000h, 074h, 0cch, 0cch, 083h, 00ch, 00ch
 db 000h, 000h, 0d8h, 013h, 0c0h, 0c0h, 0c0h, 000h, 000h, 000h, 083h, 0c0h, 007h, 00ch, 007h, 000h
 db 060h, 060h, 0f0h, 060h, 060h, 068h, 030h, 000h, 000h, 000h, 0d8h, 0d8h, 0d8h, 0d8h, 06ch, 000h
 db 000h, 000h, 0c8h, 0c4h, 0c4h, 048h, 030h, 000h, 000h, 000h, 0c8h, 0c4h, 0d4h, 0d4h, 068h, 000h
 db 000h, 000h, 0c4h, 068h, 030h, 068h, 0c4h, 000h, 000h, 000h, 0c4h, 0c4h, 0cch, 074h, 004h, 078h
 db 000h, 000h, 003h, 018h, 030h, 060h, 003h, 000h, 01ch, 030h, 030h, 060h, 030h, 030h, 01ch, 000h
 db 030h, 030h, 030h, 000h, 030h, 030h, 030h, 000h, 0e0h, 030h, 030h, 018h, 030h, 030h, 0e0h, 000h
 db 000h, 000h, 070h, 09ah, 00ch, 000h, 000h, 000h, 010h, 030h, 081h, 001h, 081h, 030h, 010h, 000h
 db 010h, 038h, 083h, 001h, 001h, 038h, 083h, 000h, 06ch, 001h, 001h, 001h, 083h, 038h, 010h, 000h
 db 038h, 038h, 001h, 001h, 029h, 010h, 083h, 000h, 010h, 038h, 083h, 001h, 083h, 038h, 010h, 000h
 db 000h, 078h, 084h, 084h, 084h, 084h, 078h, 000h, 000h, 078h, 003h, 003h, 003h, 003h, 078h, 000h
 db 020h, 007h, 026h, 03ch, 044h, 040h, 0c1h, 000h, 000h, 000h, 010h, 083h, 03ch, 05ah, 034h, 000h
 db 000h, 000h, 000h, 044h, 042h, 052h, 020h, 000h, 000h, 000h, 03ch, 0c1h, 042h, 002h, 01ch, 000h
 db 000h, 000h, 018h, 081h, 004h, 018h, 091h, 000h, 000h, 000h, 012h, 081h, 03ch, 052h, 034h, 000h
 db 000h, 000h, 048h, 003h, 04ah, 042h, 024h, 000h, 000h, 000h, 008h, 043h, 0cah, 00ch, 038h, 000h
 db 000h, 000h, 008h, 00eh, 038h, 04ch, 03ah, 000h, 000h, 000h, 000h, 083h, 002h, 002h, 01ch, 000h
 db 038h, 044h, 08eh, 092h, 0e2h, 044h, 038h, 000h, 020h, 003h, 028h, 03ch, 06ah, 092h, 064h, 000h
 db 000h, 044h, 082h, 082h, 082h, 090h, 060h, 000h, 038h, 000h, 083h, 082h, 002h, 004h, 038h, 000h
 db 038h, 000h, 041h, 044h, 008h, 038h, 031h, 000h, 020h, 085h, 022h, 03ch, 062h, 0a2h, 06ch, 000h
 db 020h, 00bh, 02ah, 04ah, 048h, 088h, 030h, 000h, 010h, 083h, 008h, 0c1h, 084h, 080h, 083h, 000h
 db 00ch, 018h, 020h, 040h, 020h, 018h, 00ch, 000h, 088h, 084h, 041h, 084h, 084h, 084h, 048h, 000h
 db 000h, 083h, 002h, 004h, 040h, 040h, 0c1h, 000h, 020h, 016h, 007h, 008h, 044h, 080h, 083h, 000h
 db 080h, 040h, 040h, 040h, 042h, 044h, 038h, 000h, 008h, 001h, 008h, 038h, 048h, 038h, 008h, 010h
 db 004h, 044h, 001h, 044h, 04ch, 040h, 0c1h, 000h, 083h, 018h, 0c1h, 0d0h, 020h, 020h, 01ch, 000h
 db 022h, 098h, 02dh, 062h, 046h, 0b4h, 019h, 044h, 000h, 000h, 000h, 000h, 060h, 090h, 060h, 000h
 db 03ch, 030h, 030h, 030h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 018h, 018h, 018h, 078h, 000h
 db 000h, 000h, 000h, 000h, 0c0h, 060h, 060h, 000h, 000h, 000h, 000h, 030h, 030h, 000h, 000h, 000h
 db 001h, 002h, 001h, 002h, 004h, 018h, 060h, 000h, 000h, 000h, 007h, 008h, 030h, 020h, 040h, 000h
 db 000h, 000h, 00ch, 030h, 0d0h, 010h, 010h, 000h, 000h, 020h, 007h, 088h, 008h, 010h, 060h, 000h
 db 000h, 000h, 007h, 020h, 020h, 020h, 007h, 000h, 000h, 010h, 007h, 030h, 050h, 090h, 010h, 000h
 db 000h, 040h, 003h, 044h, 048h, 040h, 020h, 000h, 000h, 000h, 078h, 008h, 008h, 008h, 003h, 000h
 db 000h, 000h, 007h, 008h, 007h, 008h, 007h, 000h, 000h, 000h, 0a4h, 0a4h, 004h, 008h, 070h, 000h
 db 000h, 000h, 080h, 081h, 000h, 000h, 000h, 000h, 001h, 002h, 014h, 018h, 010h, 020h, 040h, 000h
 db 006h, 008h, 018h, 068h, 008h, 008h, 008h, 000h, 010h, 001h, 082h, 082h, 004h, 008h, 030h, 000h
 db 000h, 001h, 010h, 010h, 010h, 010h, 001h, 000h, 004h, 001h, 00ch, 00ch, 014h, 024h, 0c4h, 000h
 db 010h, 081h, 012h, 022h, 022h, 042h, 046h, 000h, 010h, 081h, 010h, 001h, 010h, 010h, 010h, 000h
 db 0c1h, 022h, 042h, 002h, 004h, 004h, 008h, 000h, 040h, 081h, 048h, 088h, 008h, 010h, 020h, 000h
 db 000h, 081h, 002h, 002h, 002h, 002h, 081h, 000h, 044h, 001h, 044h, 044h, 004h, 008h, 030h, 000h
 db 000h, 072h, 002h, 072h, 002h, 004h, 007h, 000h, 000h, 001h, 002h, 004h, 008h, 034h, 0c2h, 000h
 db 040h, 001h, 044h, 044h, 048h, 040h, 0c1h, 000h, 042h, 042h, 022h, 004h, 004h, 018h, 060h, 000h
 db 0c1h, 022h, 0a1h, 042h, 004h, 004h, 018h, 000h, 002h, 083h, 008h, 001h, 008h, 010h, 060h, 000h
 db 052h, 052h, 052h, 004h, 004h, 008h, 070h, 000h, 083h, 000h, 001h, 008h, 008h, 010h, 060h, 000h
 db 020h, 020h, 020h, 038h, 026h, 020h, 020h, 000h, 008h, 081h, 008h, 008h, 008h, 008h, 030h, 000h
 db 000h, 03ch, 000h, 000h, 000h, 000h, 081h, 000h, 000h, 081h, 002h, 081h, 004h, 018h, 019h, 000h
 db 010h, 001h, 004h, 018h, 074h, 092h, 010h, 000h, 002h, 002h, 004h, 004h, 008h, 030h, 0c0h, 000h
 db 010h, 008h, 044h, 044h, 044h, 044h, 082h, 000h, 040h, 042h, 083h, 040h, 040h, 042h, 03ch, 000h
 db 001h, 002h, 002h, 002h, 004h, 018h, 060h, 000h, 000h, 020h, 050h, 088h, 084h, 002h, 000h, 000h
 db 010h, 001h, 010h, 054h, 052h, 092h, 010h, 000h, 000h, 001h, 002h, 004h, 028h, 010h, 00ch, 000h
 db 003h, 000h, 078h, 000h, 000h, 003h, 002h, 000h, 010h, 020h, 040h, 040h, 084h, 082h, 001h, 002h
 db 002h, 002h, 032h, 00ch, 004h, 01ah, 0e2h, 000h, 083h, 020h, 001h, 020h, 020h, 020h, 01eh, 000h
 db 040h, 001h, 042h, 044h, 058h, 040h, 040h, 000h, 000h, 083h, 004h, 004h, 004h, 004h, 001h, 000h
 db 000h, 081h, 002h, 081h, 002h, 002h, 081h, 000h, 083h, 000h, 001h, 002h, 002h, 004h, 038h, 000h
 db 044h, 044h, 044h, 044h, 004h, 008h, 030h, 000h, 010h, 050h, 050h, 052h, 052h, 054h, 098h, 000h
 db 080h, 080h, 080h, 082h, 084h, 088h, 0f0h, 000h, 000h, 001h, 082h, 082h, 082h, 082h, 001h, 000h
 db 001h, 082h, 082h, 002h, 002h, 004h, 038h, 000h, 000h, 0e0h, 012h, 002h, 002h, 004h, 007h, 000h
 db 090h, 048h, 000h, 000h, 000h, 000h, 000h, 000h, 060h, 090h, 060h, 000h, 000h, 000h, 000h, 000h
 db 020h, 001h, 040h, 05ch, 082h, 0a0h, 061h, 000h, 020h, 001h, 040h, 083h, 082h, 002h, 03ch, 000h
 db 000h, 043h, 042h, 002h, 002h, 004h, 038h, 000h, 000h, 003h, 010h, 020h, 040h, 040h, 038h, 000h
 db 020h, 016h, 018h, 020h, 040h, 040h, 0c1h, 000h, 024h, 005h, 044h, 044h, 09ch, 0a6h, 018h, 000h
 db 09ch, 0a2h, 084h, 080h, 080h, 0a0h, 0a1h, 000h, 008h, 05ch, 06ah, 052h, 049h, 0aah, 04ch, 000h
 db 040h, 013h, 052h, 062h, 031h, 04ah, 04ch, 000h, 000h, 03ch, 052h, 092h, 0a2h, 0a2h, 044h, 000h
 db 004h, 041h, 084h, 084h, 09ch, 0a6h, 05ch, 000h, 008h, 04ch, 0c6h, 044h, 044h, 048h, 030h, 000h
 db 020h, 018h, 020h, 014h, 08ah, 0cah, 030h, 000h, 000h, 000h, 030h, 068h, 0c4h, 006h, 002h, 000h
 db 041h, 084h, 041h, 084h, 09ch, 0a6h, 05ah, 000h, 008h, 081h, 008h, 081h, 038h, 04ch, 032h, 000h
 db 010h, 074h, 014h, 081h, 0a4h, 0a4h, 048h, 000h, 020h, 007h, 022h, 062h, 0a0h, 062h, 01ch, 000h
 db 048h, 05ch, 06ah, 0cah, 0b2h, 0a2h, 054h, 000h, 040h, 040h, 007h, 040h, 005h, 042h, 03ch, 000h
 db 040h, 048h, 083h, 0cah, 042h, 04ch, 040h, 020h, 008h, 043h, 04ah, 08ah, 043h, 008h, 030h, 000h
 db 008h, 008h, 00eh, 008h, 078h, 08ch, 072h, 000h, 038h, 084h, 080h, 043h, 0c2h, 002h, 03ch, 000h
 db 004h, 042h, 042h, 042h, 062h, 004h, 018h, 000h, 083h, 008h, 030h, 023h, 062h, 092h, 083h, 000h
 db 024h, 02ch, 00bh, 024h, 064h, 0a4h, 022h, 000h, 083h, 008h, 01ch, 062h, 082h, 004h, 018h, 000h
 db 040h, 060h, 023h, 062h, 042h, 0c2h, 05ch, 000h, 020h, 020h, 040h, 070h, 0c8h, 08ah, 084h, 000h
 db 0aah, 055h, 0aah, 055h, 0aah, 055h, 0aah, 055h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
end.bg.gen:
bg.col:
 db 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h
 db 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 081h, 091h, 0a2h, 0b3h, 0c4h, 0d5h, 0e6h, 0f7h
 db 001h, 01ah, 01bh, 01ah, 01ah, 019h, 01ah, 001h, 001h, 012h, 013h, 012h, 012h, 01ch, 012h, 001h
 db 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h
 db 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 091h, 019h, 019h, 069h, 096h
 db 001h, 001h, 001h, 061h, 061h, 016h, 016h, 006h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h
 db 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 091h, 081h, 061h, 061h, 061h, 061h, 061h, 091h
 db 091h, 081h, 061h, 061h, 061h, 016h, 016h, 061h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h
 db 091h, 091h, 091h, 019h, 019h, 019h, 096h, 096h, 096h, 096h, 096h, 096h, 006h, 006h, 006h, 006h
 db 006h, 006h, 006h, 006h, 006h, 006h, 006h, 006h, 061h, 061h, 061h, 016h, 016h, 006h, 016h, 016h
 db 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 016h, 016h, 016h, 016h, 016h, 019h, 016h, 006h
 db 061h, 016h, 016h, 016h, 061h, 016h, 016h, 016h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h
 db 096h, 006h, 006h, 006h, 006h, 006h, 061h, 001h, 006h, 006h, 016h, 016h, 016h, 06ah, 01ah, 01bh
 db 016h, 016h, 061h, 061h, 061h, 01ah, 01ah, 0abh, 016h, 061h, 061h, 061h, 061h, 001h, 001h, 001h
 db 061h, 061h, 091h, 061h, 061h, 061h, 091h, 061h, 006h, 006h, 006h, 016h, 016h, 016h, 016h, 016h
 db 016h, 016h, 016h, 016h, 016h, 016h, 016h, 016h, 061h, 061h, 061h, 061h, 061h, 061h, 061h, 061h
 db 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 01bh, 01bh, 01bh, 01bh, 01bh, 01bh, 0abh, 01bh
 db 01bh, 01ah, 0bah, 0bah, 0bah, 0bah, 01ah, 01ah, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h
 db 061h, 061h, 016h, 016h, 061h, 0b1h, 01bh, 01bh, 006h, 006h, 016h, 061h, 016h, 061h, 0b1h, 00bh
 db 016h, 016h, 016h, 016h, 016h, 016h, 001h, 00bh, 061h, 061h, 061h, 061h, 061h, 0b1h, 01bh, 01bh
 db 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 01bh, 01bh, 01bh, 0b1h, 0b1h, 0b1h, 0b1h, 0b1h
 db 01ah, 01ah, 01ah, 01ah, 0a1h, 0a1h, 0a1h, 0a1h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h
 db 01bh, 00bh, 00bh, 00bh, 00bh, 01bh, 01bh, 0b1h, 00bh, 00bh, 00bh, 00bh, 00bh, 00bh, 00bh, 0abh
 db 00bh, 00bh, 00bh, 00bh, 00bh, 00bh, 0bah, 00ah, 01bh, 0abh, 0abh, 0abh, 0abh, 0bah, 01ah, 0a1h
 db 01fh, 0f1h, 01fh, 01fh, 01fh, 0f1h, 01fh, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h
 db 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 001h, 01fh, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 01fh, 001h
 db 01fh, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 01fh, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 01fh, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 01fh, 001h, 01fh, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 0f1h, 0f1h, 001h, 001h, 0f1h, 0f1h, 001h, 001h, 0f1h, 0f1h, 001h, 001h, 0f1h, 0f1h, 0f1h
 db 0f1h, 0f1h, 01fh, 01fh, 01fh, 0f1h, 0f1h, 001h, 001h, 001h, 01fh, 001h, 01fh, 001h, 001h, 001h
 db 0f1h, 0f1h, 01fh, 01fh, 01fh, 0f1h, 0f1h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 001h
 db 01fh, 0f1h, 01fh, 0f1h, 01fh, 0f1h, 01fh, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 001h
 db 01fh, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 01fh, 001h, 01fh, 01fh, 0f1h, 0f1h, 0f1h, 01fh, 01fh, 001h
 db 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h, 01fh, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 01fh, 001h
 db 01fh, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h, 01fh, 01fh, 0f1h, 01fh, 0f1h, 01fh, 01fh, 001h
 db 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h, 0f1h, 01fh, 01fh, 01fh, 01fh, 0f1h, 0f1h, 001h
 db 0f1h, 01fh, 01fh, 01fh, 01fh, 01fh, 0f1h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h
 db 01fh, 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 01fh, 01fh, 01fh, 001h
 db 01fh, 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 01fh, 001h, 01fh, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 01fh, 001h
 db 01fh, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 001h, 0f1h, 0f1h, 01fh, 01fh, 01fh, 01fh, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 01fh, 0f1h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 01fh, 001h
 db 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 0f1h, 0f1h, 01fh, 0f1h, 01fh, 001h
 db 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 01fh, 001h, 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 0f1h, 0f1h, 01fh, 0f1h, 01fh, 001h
 db 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h
 db 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 01fh, 01fh, 01fh, 01fh, 01fh, 001h
 db 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 001h, 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 001h, 001h, 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h
 db 001h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 01fh, 0f1h, 01fh, 0f1h, 01fh, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h
 db 001h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 01fh, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 001h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 001h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 0f1h, 0f1h, 01fh, 01fh, 01fh, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 01fh, 01fh, 01fh, 0f1h, 01fh, 001h, 0f1h, 01fh, 01fh, 01fh, 01fh, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 01fh, 01fh, 01fh, 0f1h, 01fh, 001h, 0f1h, 0f1h, 01fh, 01fh, 01fh, 0f1h, 0f1h, 001h
 db 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 0f1h, 01fh, 01fh, 01fh, 01fh, 0f1h, 001h
 db 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h, 001h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 01fh, 001h, 001h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 01fh, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 01fh, 0f1h, 01fh, 0f1h, 0f1h, 01fh, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 01fh, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h
 db 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 01fh, 001h, 01fh, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 001h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 001h, 001h, 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 001h, 001h, 001h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 001h, 0f1h, 0f1h, 001h, 001h, 001h
 db 01fh, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 01fh, 001h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h
 db 001h, 001h, 01fh, 0f1h, 01fh, 0f1h, 01fh, 001h, 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 001h, 0f1h, 01fh, 001h, 001h, 001h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 01fh, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h
 db 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 01fh, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 01fh, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 01fh, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 0f1h, 001h, 001h, 001h, 001h, 01fh, 001h, 001h, 01fh, 0f1h, 01fh, 0f1h, 0f1h, 01fh, 001h
 db 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h
 db 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 01fh, 001h, 0f1h, 001h, 001h, 01fh, 0f1h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 0f1h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 01fh, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h
 db 001h, 01fh, 0f1h, 01fh, 0f1h, 0f1h, 01fh, 001h, 01fh, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h
 db 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h
 db 0f1h, 0f1h, 001h, 001h, 001h, 001h, 001h, 001h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 001h, 001h
 db 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h, 0f1h, 01fh, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h
 db 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 001h
 db 0f1h, 01fh, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 001h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 01fh, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 01fh, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 0f1h, 01fh, 0f1h, 01fh, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 01fh, 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 01fh, 001h
 db 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 01fh, 0f1h, 0f1h, 0f1h, 0f1h, 001h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 001h
 db 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 0f1h, 00fh, 00fh, 00fh, 00fh, 00fh, 00fh, 00fh, 00fh
end.bg.col:
;include z_ram
 ds 8000h-$, 0
;--begin RAM area
;--end RAM area
; self-rewrite label
;end of include z_ram
; defwork,endwork moved to z_ram
;--begin RAM area
h.unreach:
 jp h.nop
;--end RAM area
;--begin RAM area
;--end RAM area
xrnd.seed:
 dw 1234
 dw 5678
hexval:
 dw 0
trad:
 db 65
cursor:
 dw 1800h
;--begin RAM area
;(hl)->sp
;sp->(hl)
;--end RAM area
sptmp:
 dw 0
sva:
 db 0
;--begin RAM area
h.tntimi:
 jp h.nop
;--end RAM area
timecnt:
 db 0
th.new.start:
 db th.start.h
th.new.end:
 db th.end.h
th.kill.reserve:
 db 0
;--begin RAM area
th.yield:
 ld hl,(th.cur)
 ld l,th.ofs.sp
;sp->(hl)
 ld (L65.spad-2),hl
 ld (0),sp
L65.spad:
adrssp:
 ld sp,0
 jp doint
 ret
;--end RAM area
;--begin RAM area
th.with.s:
; with(this) { init routine } 
;  init routine should end with th.with.ret
; h -> this
; th.with.setdst <addr> -> init routine address
 ld (th.wrssp-2),sp
 ld l, th.ofs.sp
 ld (th.updsp-2),hl
;(hl)->sp
 ld (L66.rs-2),hl
 ld sp,(0)
L66.rs:
 jp 0
th.jpdest:
th.ewith:
 ld (0),sp
th.updsp:
 ld sp,0
th.wrssp:
 ret
th.push:
;push bc to thread hl
 push hl
 ld hl,tpsbc
 ld (th.jpdest-2),hl
 pop hl
 call th.with.s
 ret
tpsbc:
  push bc
 jp th.ewith
 ret
th.loop:
; hook before stepall
 call h.thent
; save prev timecnt
 ld a,(timecnt)
 push af
  call th.stepall
; hook after stepall
  call h.thlop
; wait until timecnt changes
 pop af
bwat:
  ld hl,timecnt
  cp (hl)
  jr nz,bbwat
  push af
  call doint
  pop af
  jr bwat
bbwat:
; repeat
 jr th.loop
 ret
h.thent:
 jp h.nop
h.thlop:
 jp h.nop
;--end RAM area
th.cur:
 dw 0
;--begin RAM area
; pushthis before arg push
; hl=target
; popthis after
;hl=tg
; stk=val hl=tg
h.getfld.hl.rom:
 db 2ah; ld hl,(nn)
getfld.hl.rom.fld:
 db 0
getfld.hl.rom.tg:
 db 0
 ret
 ret
h.getfld.de.rom:
;01RP1011
;01011011
 db 0edh, 5bh; ld de,(nn)
getfld.de.rom.fld:
 db 0
getfld.de.rom.tg:
 db 0
 ret
 ret
h.setfld.rom:
 db 22h ; ld (nn),hl
setfld.rom.fld:
 db 0
setfld.rom.tg:
 db 0
 ret
 ret
;--end RAM area
;--begin RAM area
o.new:
; {val .f} n &initbl retad
 pop hl;retad
 ld (L67.retad-2),hl
; set initbl for th.with
 pop hl;&initbl
 ld (th.jpdest-2),hl
; save this
 ld (L67.svthis-1),a
; allocate thread
 call th.new
 jr nz, L67.allocfail
 push hl; thread address
 call th.with.s; call &initbl
 pop hl; thread address
 ld a,h; set this as thread
; init fields
 pop bc; n of {val .f}
 inc c
L67.loop:
  dec c
  jr z,L67.lpend
  pop hl; .f
  ld h,a
  ld (L67.w-2),hl
  pop hl; val
  ld (L67.w),hl
L67.w:
 jr L67.loop
L67.lpend:
; return h as this
 ld h,a
L67.finally:
;restore a before call o.new
  ld a,0
L67.svthis:
;ret 
  jp 0
L67.retad:
L67.allocfail:
; drop {val .f}
  pop bc; n of {val .f}
  ld b,c
  inc c
L67.lp2:
   dec c
   jr z, L67.lp2end
   pop hl
   pop hl
  jr L67.lp2
L67.lp2end:
  ld hl,null;  todo null
  jr L67.finally
 ret
;--end RAM area
this:
 db 0
;--begin RAM area
o.boot:
 ld a,(th.cur+1)
 ld (this),a
 ld ($+5),a
 ld hl,(.main)
 push hl
 ld hl,$+5
 ex (sp),hl
 jp (hl); call hl
 ld a,(this)
 ret
;--end RAM area
;--begin RAM area
instanceof:
; a=this de=Class
; z: true
 ld ($+5),a
 ld hl,(.class)
 jp is.subclass.a
 ret
get.superclass:
; hl=Class
 dec hl
 dec hl
  ld (L68.w-2),hl
  ld hl,(0)
L68.w:
 ret
;--end RAM area
;--begin RAM area
spr.puts:
 call spr.putslp
 ld a,(spr.puts.s)
 cp 1
 jr nz,L69.rdir
  ld a, th.count-1
  ld (spr.puts.s),a
  ret
L69.rdir:
 ld a,1
 ld (spr.puts.s),a
 ld a,(spr.puts.b)
 inc a
 cp th.end.h
 jr c,L69.rsta
  sub th.count
L69.rsta:
 ld (spr.puts.b),a
 ret
;--end RAM area
spr.puts.b:
 db th.start.h
spr.puts.s:
 db 1
gbl_offsetY:
 dw 0
gbl_offsetX:
 dw 0
;--begin RAM area
;defsub spr.put1_new
spr.put1:
; a: th.id
; uses c
 ld (L70.t1-1),a
 ld (L70.t2-1),a
 ld (L70.t3-1),a
 ld (L70.t4-1),a
  ld h,a
  call th.isblank.a
  ret z
 ld a,(this)
 ld hl,(.y)
L70.t1:
  ld de,(gbl_offsetY)
 and a
 sbc hl,de
  bit 7,h
  jp nz, L70.setsco
  ld de,spr.ymax
 rst dcompr
  jp nc, L70.setsco
; HL -> A
 srl h
 rr l
 LD A,L
  sub 8
  ld c,a
 ld hl,(.x)
L70.t2:
  ld de,(gbl_offsetX)
 and a
 sbc hl,de
  bit 7,h
  jp nz, L70.setsco
  ld de,spr.xmax
 rst dcompr
  jp nc,L70.setsco
  ld a,c
  out (98h),a
 and a
 sbc hl,de
; HL -> A
 srl h
 rr l
 LD A,L
  sub 8
  out (98h),a
 ld a,(.p)
L70.t3:
  sla a
  sla a
  out (98h),a
 ld a,(.c)
L70.t4:
  out (98h),a
 ld a,(this)
  ld h,a
  ld l,.statusReg+1
  res 7,(hl)
  ret 
L70.setsco:
 ld a,(this)
  ld h,a
  ld l,.statusReg+1
  set 7,(hl)
 ret
spr.put1_old:
;defsub spr.put1
; a: th.id
  push af
 ld (L71.t1-1),a
 ld (L71.t2-1),a
 ld (L71.t3-1),a
 ld (L71.t4-1),a
  ld h,a
  call th.isblank.a
  jr nz,L71.has
; ld a,x is needed
; since OpenMSX may reproduce the "nightmare" 
; described in https://www.msx.org/wiki/Compatibility_testing
; > The real machine is very picky with VDP timing. If you write too fast to the VDP, it might corrupt data.
   ld a,240
  out (98h),a
   ld a,0
  out (98h),a
   ld a,0
  out (98h),a
   ld a,0
  out (98h),a
   pop af
   ret
L71.has:
 ld hl,(.y)
L71.t1:
; HL -> A
 srl h
 rr l
 LD A,L
  sub 8
  out (98h),a
 ld hl,(.x)
L71.t2:
; HL -> A
 srl h
 rr l
 LD A,L
  sub 8
  out (98h),a
 ld a,(.p)
L71.t3:
  sla a
  sla a
  out (98h),a
 ld a,(.c)
L71.t4:
  out (98h),a
  pop af
 ret
;--end RAM area
keyuse:
 db 1
keymat1:
 ds 13, 0
keymat2:
 ds 13, 0
trig2mat:
 db 0
;  rdul
 db 00100000b
 db 10100000b
 db 10000000b
 db 11000000b
 db 01000000b
 db 01010000b
 db 00010000b
 db 00110000b
;--begin RAM area
MZO.init.ch:
 dw 0
MZO.init.mp:
 dw 0
;--end RAM area
;--begin RAM area
MZO.stop.chn:
 dw 0
MZO.stop.ch:
 dw 0
;--end RAM area
;--begin RAM area
MZO.step.chn:
 dw 0
MZO.step.mpoint:
 dw 0
MZO.step.mcount:
 dw 0
MZO.step.tempoc:
 dw 0
MZO.step.len:
 dw 0
MZO.step.v:
 dw 0
MZO.step.cmd:
 dw 0
MZO.step.ofs:
 dw 0
MZO.step.ch:
 dw 0
;--end RAM area
;--begin RAM area
MZO.initBGM.size:
 dw 0
MZO.initBGM.mpoint:
 dw 0
;--end RAM area
;--begin RAM area
MZO.initSE.size:
 dw 0
MZO.initSE.mpoint:
 dw 0
;--end RAM area
;--begin RAM area
MZO.stopBGM.i:
 dw 0
;--end RAM area
;--begin RAM area
MZO.stepAll.i:
 dw 0
;--end RAM area
;--begin RAM area
MZOgbl_mpoint:
 dw 0, 0, 0, 0
MZOgbl_mcount:
 dw 0, 0, 0, 0
MZOgbl_v:
 dw 0, 0, 0, 0
MZOgbl_len:
 dw 0, 0, 0, 0
MZOgbl_tempoc:
 dw 0, 0, 0, 0
MZOgbl_mute:
 dw 0, 0, 0, 0;
MZOgbl_psgs:dw 0
;--end RAM area
;--begin RAM area
;trace mesg
 call h.unreach
 dw Sprite
RActor:
; .class equ 250
 ld bc,RActor
 push bc
; .statusReg equ 248
 ld bc,0
 push bc
;keep'em. used in FldIdx
;fld .class,Class
;fld .statusReg,0
; .main equ 246
 ld bc,RActor.main
 push bc
; .x equ 244
 ld bc,0
 push bc
; .y equ 242
 ld bc,-1024
 push bc
; .p equ 240
 ld bc,0
 push bc
; .c equ 238
 ld bc,3
 push bc
.onUpdate equ 236
 ld bc,RActor.onUpdate
 push bc
.update equ 234
 ld bc,RActor.update
 push bc
.screenOut equ 232
 ld bc,RActor.screenOut
 push bc
.die equ 230
 ld bc,RActor.die
 push bc
.updateEx equ 228
 ld bc,RActor.updateEx
 push bc
.crashTo equ 226
 ld bc,RActor.crashTo
 push bc
 ld bc,RActor.wait
 push bc
 ld bc,o.boot
 push bc
 jp th.ewith
RActor.main:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
 ld sp,ix
 pop ix
 ret
RActor.update:
 ld ($+5),a
 ld hl,(.onUpdate)
 push hl
 ld hl,$+5
 ex (sp),hl
 jp (hl); call hl
 ld a,(this)
 ld a,(this)
 push af
 push ix
 call th.yield
 pop ix
  ex (sp),hl
  ld a,h
  pop HL
 ld (this),a
 ret
RActor.onUpdate:
 ret
RActor.screenOut:
 ld ($+5),a
 ld hl,(.x)
 ld de,(gbl_offsetX)
 and a
 sbc hl,de
 ld de,256 << spr.scale
 and a
 sbc hl,de
 jr nc, L72.lb_true
 ld ($+5),a
 ld hl,(.y)
 ld de,(gbl_offsetY)
 and a
 sbc hl,de
 ld de,192 << spr.scale
 and a
 sbc hl,de
 jr nc, L72.lb_true
 ld hl,false
 and a
 ret
L72.lb_true:
 ld hl,true
 scf
 ret
RActor.wait:
L73.lbl:
 ld ($+5),a
 ld hl,(.update)
 push hl
 ld hl,$+5
 ex (sp),hl
 jp (hl); call hl
 ld a,(this)
 jr L73.lbl
RActor.die:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
 ld h,a
 push af
 call th.kill.a
 pop af
 ld sp,ix
 pop ix
 ret
RActor.updateEx:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
; enter 0
 ld l,(ix+argidx+1*2)
 ld h,(ix+argidx+1*2+1)
L74.n:
 ld a,(this)
  push hl
 ld ($+5),a
 ld hl,(.update)
 push hl
 ld hl,$+5
 ex (sp),hl
 jp (hl); call hl
 ld a,(this)
  pop hl
  dec hl
  ld a,h
  or l
 jr nz,L74.n
 ld a,(this)
 ld sp,ix
 pop ix
  exx
  pop bc
  inc sp
  inc sp
  push bc
  exx
 ret
crashTo.size equ 8<<spr.scale
crashTo.setXY:
 ld ($+5),a
 ld hl,(.x)
 ld (cr.gx-2),hl
 ld ($+5),a
 ld hl,(.y)
 ld (cr.gy-2),hl
 ret
RActor.crashTo:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
 call crashTo.setXY
 ld l,(ix+argidx+1*2)
 ld h,(ix+argidx+1*2+1)
;const cr.class,hl
 call isobj.a
 jr c, L75.cr1
;trace mesg
 call h.unreach
; "Cannot call target.crashTo(Class) "
L75.cr1:
 ld a,(this)
  call crashTo1
 jr c, L76.yes
  ld hl,false
  jr L76.skp
L76.yes:
  ld hl,true
L76.skp:
 ld sp,ix
 pop ix
  exx
  pop bc
  inc sp
  inc sp
  push bc
  exx
 ret
;--end RAM area
;--begin RAM area
crashTo1:
; call crashTo.setXY before
;hl=tg
;cy:true
;hl is used
 push af
 ld a,h
 ld (cr.t1-1),a
 ld (cr.t2-1),a
 pop af
 ld hl,(.x)
cr.t1:
 ld bc,0
cr.gx:
 and a
 sbc hl,bc
 call abs
 ld bc,crashTo.size
 and a
 sbc hl,bc
 ret nc
 ld hl,(.y)
cr.t2:
 ld bc,0
cr.gy:
 and a
 sbc hl,bc
 call abs
 ld bc,crashTo.size
 and a
 sbc hl,bc
 ret
;--end RAM area
gbl_frameCount:
 dw 0
;--begin RAM area
all.die:
 ld a,(this)
 push af
 ld a,0+(th.start.h)
L78.loop:
  cp th.count+(th.start.h)
  jp nc, L77.nxt
  push af
  ld h,a
  ld l,0
  call L78.do
  ex (sp),hl
  ld a,h
  pop HL
  ld h,a
  ld l,0
  jp c, L77.nxt
  inc a
 jr L78.loop
L78.do:
  call th.isblank.a
  jr nz,L79.jj
;jr cnd, skip
;jr to
;skip:
 or a
 ret
L79.jj:
 ld a,h
 ld (this),a
 ld ($+5),a
 ld hl,(.die)
 push hl
 ld hl,$+5
 ex (sp),hl
 jp (hl); call hl
 or a
 ret
L77.nxt:
  ex (sp),hl
  ld a,h
  pop HL
 ld (this),a
 ret
;--end RAM area
strbuf.i:
 ds 16, 0
;--begin RAM area
; class_def_start Laser
;range 0-32
;trace mesg
 call h.unreach
 dw RActor
Laser:
; .class equ 250
 ld bc,Laser
 push bc
; .statusReg equ 248
 ld bc,0
 push bc
; .main equ 246
 ld bc,Laser.main
 push bc
 ld bc,0
 push bc
; .y equ 242
 ld bc,0
 push bc
 ld bc,0
 push bc
 ld bc,0
 push bc
; .onUpdate equ 236
 ld bc,RActor.onUpdate
 push bc
; .update equ 234
 ld bc,RActor.update
 push bc
; .screenOut equ 232
 ld bc,RActor.screenOut
 push bc
; .die equ 230
 ld bc,RActor.die
 push bc
; .updateEx equ 228
 ld bc,RActor.updateEx
 push bc
; .crashTo equ 226
 ld bc,RActor.crashTo
 push bc
.wat equ 224
 ld bc,0
 push bc
.i equ 222
 ld bc,0
 push bc
.imod equ 220
 ld bc,0
 push bc
.mesg equ 218
 ld bc,0
 push bc
.lim equ 216
 ld bc,0
 push bc
 ld bc,RActor.wait
 push bc
 ld bc,o.boot
 push bc
 jp th.ewith
Laser.main:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
;wat=5-($scb>>4);
 ld hl,4; const val
 push hl
 ld hl,(gbl_scb)
 pop bc
 ld b,c
L81.loop:
 sra h
 rr l
  djnz L81.loop
 push hl
 ld hl,5; const val
 pop de
 and a
 sbc hl,de
 ld ($+5),a
 ld (.wat),hl
;if wat>0
 ld hl,0; const val
 push hl
 ld ($+5),a
 ld hl,(.wat)
 pop de
 call hlgtde
;then
 call ziffalse
 jp z,L80.lb1
;for i=0;
;i=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.i),hl
L80.lb2:
;while i<12
 ld hl,12; const val
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call hlltde
 call ziffalse
 jp z,L80.lb3
;imod=i%3;
 ld ($+5),a
 ld hl,(.i)
 ld de,3; const val
 call div.a
 ex de,hl
 ld a,(this)
 ld ($+5),a
 ld (.imod),hl
;sound_playSE(imod==0?$se_a:imod==1?$se_g:$se_f);
 ld hl,0; const val
 push hl
 ld ($+5),a
 ld hl,(.imod)
 pop de
 call hleqde
 call ziffalse
 jp z,L80.lb5
 ld hl,gbl_se_a; const val
 jp L80.lb6
L80.lb5:
 ld hl,1; const val
 push hl
 ld ($+5),a
 ld hl,(.imod)
 pop de
 call hleqde
 call ziffalse
 jp z,L80.lb7
 ld hl,gbl_se_g; const val
 jp L80.lb8
L80.lb7:
 ld hl,gbl_se_f; const val
L80.lb8:
L80.lb6:
 push hl
 call MZO.initSE
 ld a,(this)
;map_set(31,y,peek($lasers[mesg]+imod));
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld hl,31; const val
 push hl
 ld ($+5),a
 ld hl,(.mesg)
 add hl,hl
 ld de,gbl_lasers; const val
 add hl,de
  ld (L82.w-2),hl
  ld hl,(0)
L82.w:
 ld ($+6),a
 ld de,(.imod)
 add hl, de
  ld (L83.w-2),hl
  ld hl,(0)
L83.w:
 ld h,0
 ld a,l
 pop hl
 pop de
 call map.set.a
 ld a,(this)
;updateEx(wat);
 ld ($+5),a
 ld hl,(.wat)
 push hl
 call RActor.updateEx
 ld a,(this)
L80.lb4:
;next i++
 ld ($+5),a
 ld hl,(.i)
 inc hl
 ld ($+5),a
 ld (.i),hl
 jp L80.lb2
L80.lb3:
L80.lb1:
;map_set(31,y,$space);
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld hl,31; const val
 push hl
 ld hl,1; const val
 ld a,l
 pop hl
 pop de
 call map.set.a
 ld a,(this)
;sound_playSE($se_laser);
 ld hl,gbl_se_laser; const val
 push hl
 call MZO.initSE
 ld a,(this)
;for i=31;
;i=31;
 ld hl,31; const val
 ld ($+5),a
 ld (.i),hl
L80.lb9:
;while i>=0
 ld hl,0; const val
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call hlgede
 call ziffalse
 jp z,L80.lb10
;if map_get(i,y)==$space
 ld hl,1; const val
 push hl
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call map.get.a
 ld h,0
 ld l,a
 ld a,(this)
 pop de
 call hleqde
;then
 call ziffalse
 jp z,L80.lb13
;map_set(i,y,peek($lasers[mesg]+i));
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld ($+5),a
 ld hl,(.i)
 push hl
 ld ($+5),a
 ld hl,(.mesg)
 add hl,hl
 ld de,gbl_lasers; const val
 add hl,de
  ld (L84.w-2),hl
  ld hl,(0)
L84.w:
 ld ($+6),a
 ld de,(.i)
 add hl, de
  ld (L85.w-2),hl
  ld hl,(0)
L85.w:
 ld h,0
 ld a,l
 pop hl
 pop de
 call map.set.a
 ld a,(this)
 jp L80.lb12
L80.lb13:;else
 jp L80.lb10
L80.lb12:
;update();
 call RActor.update
 ld a,(this)
L80.lb11:
;next i--
 ld ($+5),a
 ld hl,(.i)
 dec hl
 ld ($+5),a
 ld (.i),hl
 jp L80.lb9
L80.lb10:
;lim=i;
 ld ($+5),a
 ld hl,(.i)
 ld ($+5),a
 ld (.lim),hl
;if lim<0
 ld hl,0; const val
 push hl
 ld ($+5),a
 ld hl,(.lim)
 pop de
 call hlltde
;then
 call ziffalse
 jp z,L80.lb14
;lim=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.lim),hl
;$scm+=2;
 ld hl,(gbl_scm)
 ld de,2; const val
 add hl, de
 ld (gbl_scm),hl
;if $scm<96
 ld hl,96; const val
 push hl
 ld hl,(gbl_scm)
 pop de
 call hlltde
;then
 call ziffalse
 jp z,L80.lb16
;map_set(23-($scm>>2),1,4);
 ld hl,1; const val
 push hl
 ld hl,2; const val
 push hl
 ld hl,(gbl_scm)
 pop bc
 ld b,c
L86.loop:
 sra h
 rr l
  djnz L86.loop
 push hl
 ld hl,23; const val
 pop de
 and a
 sbc hl,de
 push hl
 ld hl,4; const val
 ld a,l
 pop hl
 pop de
 call map.set.a
 ld a,(this)
 jp L80.lb15
L80.lb16:;else
;locate(0,1);
 ld hl,1; const val
 push hl
 ld hl,0; const val
 pop de
 call locate
;print($scm);
 ld hl,(gbl_scm)
 call printi.a
 ld a,(this)
L80.lb15:
;updateEx(30);
 ld hl,30; const val
 push hl
 call RActor.updateEx
 ld a,(this)
L80.lb14:
;for i=31;
;i=31;
 ld hl,31; const val
 ld ($+5),a
 ld (.i),hl
L80.lb17:
;while i>=lim
 ld ($+5),a
 ld hl,(.lim)
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call hlgede
 call ziffalse
 jp z,L80.lb18
;if map_get(i,y)>=128
 ld hl,128; const val
 push hl
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call map.get.a
 ld h,0
 ld l,a
 ld a,(this)
 pop de
 call hlgede
;then
 call ziffalse
 jp z,L80.lb20
;map_set(i,y,$space);
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld ($+5),a
 ld hl,(.i)
 push hl
 ld hl,1; const val
 ld a,l
 pop hl
 pop de
 call map.set.a
 ld a,(this)
L80.lb20:
;update();
 call RActor.update
 ld a,(this)
L80.lb19:
;next i--
 ld ($+5),a
 ld hl,(.i)
 dec hl
 ld ($+5),a
 ld (.i),hl
 jp L80.lb17
L80.lb18:
;die();
 call RActor.die
 ld a,(this)
L80.lbexit:
 ld sp,ix
 pop ix
 ret
; class_def_end Laser
;--end RAM area
;--begin RAM area
; class_def_start LaserR
;range 0-32
;trace mesg
 call h.unreach
 dw RActor
LaserR:
; .class equ 250
 ld bc,LaserR
 push bc
; .statusReg equ 248
 ld bc,0
 push bc
; .main equ 246
 ld bc,LaserR.main
 push bc
 ld bc,0
 push bc
; .y equ 242
 ld bc,0
 push bc
 ld bc,0
 push bc
 ld bc,0
 push bc
; .onUpdate equ 236
 ld bc,RActor.onUpdate
 push bc
; .update equ 234
 ld bc,RActor.update
 push bc
; .screenOut equ 232
 ld bc,RActor.screenOut
 push bc
; .die equ 230
 ld bc,RActor.die
 push bc
; .updateEx equ 228
 ld bc,RActor.updateEx
 push bc
; .crashTo equ 226
 ld bc,RActor.crashTo
 push bc
; .wat equ 224
 ld bc,0
 push bc
; .i equ 222
 ld bc,0
 push bc
; .imod equ 220
 ld bc,0
 push bc
; .mesg equ 218
 ld bc,0
 push bc
; .lim equ 216
 ld bc,0
 push bc
 ld bc,RActor.wait
 push bc
 ld bc,o.boot
 push bc
 jp th.ewith
LaserR.main:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
;wat=5-($scb>>4);
 ld hl,4; const val
 push hl
 ld hl,(gbl_scb)
 pop bc
 ld b,c
L88.loop:
 sra h
 rr l
  djnz L88.loop
 push hl
 ld hl,5; const val
 pop de
 and a
 sbc hl,de
 ld ($+5),a
 ld (.wat),hl
;if wat>0
 ld hl,0; const val
 push hl
 ld ($+5),a
 ld hl,(.wat)
 pop de
 call hlgtde
;then
 call ziffalse
 jp z,L87.lb21
;for i=0;
;i=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.i),hl
L87.lb22:
;while i<12
 ld hl,12; const val
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call hlltde
 call ziffalse
 jp z,L87.lb23
;imod=i&3;
 ld ($+5),a
 ld hl,(.i)
 ex de,hl
 ld hl,3; const val
; hl&=de
 ld a,h
 and d
 ld h,a
 ld a,l
 and e
 ld l,a
 ld a,(this)
 ld ($+5),a
 ld (.imod),hl
;sound_playSE(        imod==0?$se_f:imod==1?$se_g:imod==2?$se_a:$se_b);
 ld hl,0; const val
 push hl
 ld ($+5),a
 ld hl,(.imod)
 pop de
 call hleqde
 call ziffalse
 jp z,L87.lb25
 ld hl,gbl_se_f; const val
 jp L87.lb26
L87.lb25:
 ld hl,1; const val
 push hl
 ld ($+5),a
 ld hl,(.imod)
 pop de
 call hleqde
 call ziffalse
 jp z,L87.lb27
 ld hl,gbl_se_g; const val
 jp L87.lb28
L87.lb27:
 ld hl,2; const val
 push hl
 ld ($+5),a
 ld hl,(.imod)
 pop de
 call hleqde
 call ziffalse
 jp z,L87.lb29
 ld hl,gbl_se_a; const val
 jp L87.lb30
L87.lb29:
 ld hl,gbl_se_b; const val
L87.lb30:
L87.lb28:
L87.lb26:
 push hl
 call MZO.initSE
 ld a,(this)
;map_set(0,y,peek($lasers[mesg]+(i%4)));
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld hl,0; const val
 push hl
 ld ($+5),a
 ld hl,(.i)
 ld de,4; const val
 call div.a
 ex de,hl
 ld a,(this)
 push hl
 ld ($+5),a
 ld hl,(.mesg)
 add hl,hl
 ld de,gbl_lasers; const val
 add hl,de
  ld (L89.w-2),hl
  ld hl,(0)
L89.w:
 pop de
 add hl, de
  ld (L90.w-2),hl
  ld hl,(0)
L90.w:
 ld h,0
 ld a,l
 pop hl
 pop de
 call map.set.a
 ld a,(this)
;updateEx(wat);
 ld ($+5),a
 ld hl,(.wat)
 push hl
 call RActor.updateEx
 ld a,(this)
L87.lb24:
;next i++
 ld ($+5),a
 ld hl,(.i)
 inc hl
 ld ($+5),a
 ld (.i),hl
 jp L87.lb22
L87.lb23:
L87.lb21:
;map_set(0,y,$space);
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld hl,0; const val
 push hl
 ld hl,1; const val
 ld a,l
 pop hl
 pop de
 call map.set.a
 ld a,(this)
;sound_playSE($se_laser);
 ld hl,gbl_se_laser; const val
 push hl
 call MZO.initSE
 ld a,(this)
;for i=0;
;i=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.i),hl
L87.lb31:
;while i<32
 ld hl,32; const val
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call hlltde
 call ziffalse
 jp z,L87.lb32
;if map_get(i,y)==$space
 ld hl,1; const val
 push hl
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call map.get.a
 ld h,0
 ld l,a
 ld a,(this)
 pop de
 call hleqde
;then
 call ziffalse
 jp z,L87.lb35
;map_set(i,y,peek($lasers[mesg]+i));
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld ($+5),a
 ld hl,(.i)
 push hl
 ld ($+5),a
 ld hl,(.mesg)
 add hl,hl
 ld de,gbl_lasers; const val
 add hl,de
  ld (L91.w-2),hl
  ld hl,(0)
L91.w:
 ld ($+6),a
 ld de,(.i)
 add hl, de
  ld (L92.w-2),hl
  ld hl,(0)
L92.w:
 ld h,0
 ld a,l
 pop hl
 pop de
 call map.set.a
 ld a,(this)
 jp L87.lb34
L87.lb35:;else
 jp L87.lb32
L87.lb34:
;update();
 call RActor.update
 ld a,(this)
L87.lb33:
;next i++
 ld ($+5),a
 ld hl,(.i)
 inc hl
 ld ($+5),a
 ld (.i),hl
 jp L87.lb31
L87.lb32:
;if i>=32
 ld hl,32; const val
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call hlgede
;then
 call ziffalse
 jp z,L87.lb37
;lim=31;
 ld hl,31; const val
 ld ($+5),a
 ld (.lim),hl
;$scb+=2;
 ld hl,(gbl_scb)
 ld de,2; const val
 add hl, de
 ld (gbl_scb),hl
;if $scb<96
 ld hl,96; const val
 push hl
 ld hl,(gbl_scb)
 pop de
 call hlltde
;then
 call ziffalse
 jp z,L87.lb39
;map_set(8+($scb>>2),0,5);
 ld hl,0; const val
 push hl
 ld hl,2; const val
 push hl
 ld hl,(gbl_scb)
 pop bc
 ld b,c
L93.loop:
 sra h
 rr l
  djnz L93.loop
 push hl
 ld hl,8; const val
 pop de
 add hl, de
 push hl
 ld hl,5; const val
 ld a,l
 pop hl
 pop de
 call map.set.a
 ld a,(this)
 jp L87.lb38
L87.lb39:;else
;locate(28,0);
 ld hl,0; const val
 push hl
 ld hl,28; const val
 pop de
 call locate
;print($scb);
 ld hl,(gbl_scb)
 call printi.a
 ld a,(this)
L87.lb38:
;updateEx(30);
 ld hl,30; const val
 push hl
 call RActor.updateEx
 ld a,(this)
 jp L87.lb36
L87.lb37:;else
;lim=i;
 ld ($+5),a
 ld hl,(.i)
 ld ($+5),a
 ld (.lim),hl
L87.lb36:
;for i=0;
;i=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.i),hl
L87.lb40:
;while i<=lim
 ld ($+5),a
 ld hl,(.lim)
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call hllede
 call ziffalse
 jp z,L87.lb41
;if map_get(i,y)>=128
 ld hl,128; const val
 push hl
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call map.get.a
 ld h,0
 ld l,a
 ld a,(this)
 pop de
 call hlgede
;then
 call ziffalse
 jp z,L87.lb43
;map_set(i,y,$space);
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld ($+5),a
 ld hl,(.i)
 push hl
 ld hl,1; const val
 ld a,l
 pop hl
 pop de
 call map.set.a
 ld a,(this)
L87.lb43:
;update();
 call RActor.update
 ld a,(this)
L87.lb42:
;next i++
 ld ($+5),a
 ld hl,(.i)
 inc hl
 ld ($+5),a
 ld (.i),hl
 jp L87.lb40
L87.lb41:
;die();
 call RActor.die
 ld a,(this)
L87.lbexit:
 ld sp,ix
 pop ix
 ret
; class_def_end LaserR
;--end RAM area
;--begin RAM area
_main:
 ld hl, unreach.new
 ld (h.unreach+1),hl
 ld sp,sp.ini
 call screen1
 call screen2
 ld (sptmp),sp
 push hl
 ld HL,(sptmp)
 ld (hexval),HL
 call showhex
 pop HL
 push hl
 ld hl,endusr
 ld (hexval),hl
 call showhex
 pop hl
 call inipat
 ld hl,th.start
 ld (hl),0cdh
 ld de,th.start+1
 ld bc,th.size*th.count-1
 ldir
 call th.init
 ld hl, MZO.stepAll
 call setInterval
;ld a,0
;call MZOCmd
;call mus.ini
 ld bc, 0 + ((32+th.start.h)<<8) + (0+th.start.h)
 ld(th.new.start),bc
 ld bc,0
 push bc
 ld bc,Main
 push bc
 call o.new
 ld hl,onExitFrame
 ld (h.thlop+1),hl
 ld hl,keyall
 ld (h.thent+1),hl
 jp th.loop
; class_def_start Main
;range 0-32
;trace mesg
 call h.unreach
 dw RActor
Main:
; .class equ 250
 ld bc,Main
 push bc
; .statusReg equ 248
 ld bc,0
 push bc
; .main equ 246
 ld bc,Main.main
 push bc
 ld bc,0
 push bc
; .y equ 242
 ld bc,0
 push bc
 ld bc,0
 push bc
 ld bc,0
 push bc
; .onUpdate equ 236
 ld bc,RActor.onUpdate
 push bc
; .update equ 234
 ld bc,RActor.update
 push bc
; .screenOut equ 232
 ld bc,RActor.screenOut
 push bc
; .die equ 230
 ld bc,RActor.die
 push bc
; .updateEx equ 228
 ld bc,RActor.updateEx
 push bc
; .crashTo equ 226
 ld bc,RActor.crashTo
 push bc
.j equ 224
 ld bc,0
 push bc
; .i equ 222
 ld bc,0
 push bc
.cls equ 220
 ld bc,Main.cls
 push bc
; .mesg equ 218
 ld bc,0
 push bc
.demo equ 216
 ld bc,Main.demo
 push bc
 ld bc,RActor.wait
 push bc
 ld bc,o.boot
 push bc
 jp th.ewith
Main.main:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
;locate(0,0);
 ld hl,0; const val
 push hl
 ld hl,0; const val
 pop de
 call locate
;cls();
 call Main.cls
 ld a,(this)
;for i=0;
;i=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.i),hl
L94.lb44:
;while i<8
 ld hl,8; const val
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call hlltde
 call ziffalse
 jp z,L94.lb45
;new Star{        y=i*45+32,c=15,p=7,vx=(i%3)+2    };
 ld ($+5),a
 ld hl,(.i)
 ld de,45; const val
 call mul.a
 ld a,(this)
 ld de,32; const val
 add hl, de
 push hl
 ld bc,.y
 push bc
 ld hl,15; const val
 push hl
 ld bc,.c
 push bc
 ld hl,7; const val
 push hl
 ld bc,.p
 push bc
 ld ($+5),a
 ld hl,(.i)
 ld de,3; const val
 call div.a
 ex de,hl
 ld a,(this)
 ld de,2; const val
 add hl, de
 push hl
 ld bc,.vx
 push bc
 ld bc, 0 + ((32+th.start.h)<<8) + (0+th.start.h)
 ld(th.new.start),bc
 ld bc,4
 push bc
 ld bc,Star
 push bc
 call o.new
L94.lb46:
;next i++
 ld ($+5),a
 ld hl,(.i)
 inc hl
 ld ($+5),a
 ld (.i),hl
 jp L94.lb44
L94.lb45:
;if $demo!=12345
 ld hl,12345; const val
 push hl
 ld hl,(gbl_demo)
 pop de
 call hlnede
;then
 call ziffalse
 jp z,L94.lb47
;demo();
 call Main.demo
 ld a,(this)
L94.lb47:
;$gov=0;
 ld hl,0; const val
 ld (gbl_gov),hl
;sound_playBGM($se_bgms);
 ld hl,gbl_se_bgms; const val
 push hl
 call MZO.initBGM
 ld a,(this)
;new Player;
 ld bc, 0 + ((32+th.start.h)<<8) + (0+th.start.h)
 ld(th.new.start),bc
 ld bc,0
 push bc
 ld bc,Player
 push bc
 call o.new
;$s=0;
 ld hl,0; const val
 ld (gbl_s),hl
;$score=0;
 ld hl,0; const val
 ld (gbl_score),hl
;$scb=$scm=0;
 ld hl,0; const val
 ld (gbl_scm),hl
 ld (gbl_scb),hl
;locate(1,0);
 ld hl,0; const val
 push hl
 ld hl,1; const val
 pop de
 call locate
;print("Bamboo");
 ld hl,L95.st
 jp L95.nx
L95.st: db 66, 97, 109, 98, 111, 111, 0
L95.nx:
 call print.a
 ld a,(this)
;locate(24,1);
 ld hl,1; const val
 push hl
 ld hl,24; const val
 pop de
 call locate
;print("Mushroom");
 ld hl,L96.st
 jp L96.nx
L96.st: db 77, 117, 115, 104, 114, 111, 111, 109, 0
L96.nx:
 call print.a
 ld a,(this)
;$l=0;
 ld hl,0; const val
 ld (gbl_l),hl
;$mb=0;
 ld hl,0; const val
 ld (gbl_mb),hl
;$smb=0;
 ld hl,0; const val
 ld (gbl_smb),hl
L94.lb48:
;while !$gov
 ld hl,(gbl_gov)
 call nothl
 call ziffalse
 jp z,L94.lb49
;$s--;
 ld hl,(gbl_s)
 dec hl
 ld (gbl_s),hl
;if $s<0
 ld hl,0; const val
 push hl
 ld hl,(gbl_s)
 pop de
 call hlltde
;then
 call ziffalse
 jp z,L94.lb50
;new Stone{dir:$smb==0? -1 :1};
 ld hl,0; const val
 push hl
 ld hl,(gbl_smb)
 pop de
 call hleqde
 call ziffalse
 jp z,L94.lb51
 ld hl,1; const val
 call neghl
 jp L94.lb52
L94.lb51:
 ld hl,1; const val
L94.lb52:
 push hl
 ld bc,.dir
 push bc
 ld bc, 0 + ((32+th.start.h)<<8) + (0+th.start.h)
 ld(th.new.start),bc
 ld bc,1
 push bc
 ld bc,Stone
 push bc
 call o.new
;$smb=1-$smb;
 ld hl,1; const val
 ld de,(gbl_smb)
 and a
 sbc hl,de
 ld (gbl_smb),hl
;$s=200+rnd(100);
 ld hl,100; const val
 call rnd
 push hl
 ld hl,200; const val
 pop de
 add hl, de
 ld (gbl_s),hl
;locate(1,0);
 ld hl,0; const val
 push hl
 ld hl,1; const val
 pop de
 call locate
;print("Bamboo");
 ld hl,L97.st
 jp L97.nx
L97.st: db 66, 97, 109, 98, 111, 111, 0
L97.nx:
 call print.a
 ld a,(this)
L94.lb50:
;$l--;
 ld hl,(gbl_l)
 dec hl
 ld (gbl_l),hl
;if $l<0
 ld hl,0; const val
 push hl
 ld hl,(gbl_l)
 pop de
 call hlltde
;then
 call ziffalse
 jp z,L94.lb53
;y=rnd(18)+2;
 ld hl,18; const val
 call rnd
 ld de,2; const val
 add hl, de
 ld ($+5),a
 ld (.y),hl
;mesg=rnd(2);
 ld hl,2; const val
 call rnd
 ld ($+5),a
 ld (.mesg),hl
;$score++;
 ld hl,(gbl_score)
 inc hl
 ld (gbl_score),hl
;if $mb==0
 ld hl,0; const val
 push hl
 ld hl,(gbl_mb)
 pop de
 call hleqde
;then
 call ziffalse
 jp z,L94.lb55
;mesg=rnd(10);
 ld hl,10; const val
 call rnd
 ld ($+5),a
 ld (.mesg),hl
;new Laser{y,mesg};
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld bc,.y
 push bc
 ld ($+5),a
 ld hl,(.mesg)
 push hl
 ld bc,.mesg
 push bc
 ld bc, 0 + ((32+th.start.h)<<8) + (0+th.start.h)
 ld(th.new.start),bc
 ld bc,2
 push bc
 ld bc,Laser
 push bc
 call o.new
;new Laser{y:y+1,mesg};
 ld ($+5),a
 ld hl,(.y)
 ld de,1; const val
 add hl, de
 push hl
 ld bc,.y
 push bc
 ld ($+5),a
 ld hl,(.mesg)
 push hl
 ld bc,.mesg
 push bc
 ld bc, 0 + ((32+th.start.h)<<8) + (0+th.start.h)
 ld(th.new.start),bc
 ld bc,2
 push bc
 ld bc,Laser
 push bc
 call o.new
;new Laser{y:y+2,mesg};
 ld ($+5),a
 ld hl,(.y)
 ld de,2; const val
 add hl, de
 push hl
 ld bc,.y
 push bc
 ld ($+5),a
 ld hl,(.mesg)
 push hl
 ld bc,.mesg
 push bc
 ld bc, 0 + ((32+th.start.h)<<8) + (0+th.start.h)
 ld(th.new.start),bc
 ld bc,2
 push bc
 ld bc,Laser
 push bc
 call o.new
;new Laser{y:y+3,mesg};
 ld ($+5),a
 ld hl,(.y)
 ld de,3; const val
 add hl, de
 push hl
 ld bc,.y
 push bc
 ld ($+5),a
 ld hl,(.mesg)
 push hl
 ld bc,.mesg
 push bc
 ld bc, 0 + ((32+th.start.h)<<8) + (0+th.start.h)
 ld(th.new.start),bc
 ld bc,2
 push bc
 ld bc,Laser
 push bc
 call o.new
 jp L94.lb54
L94.lb55:;else
;mesg=10+rnd(10);
 ld hl,10; const val
 call rnd
 push hl
 ld hl,10; const val
 pop de
 add hl, de
 ld ($+5),a
 ld (.mesg),hl
;new LaserR{y,mesg};
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld bc,.y
 push bc
 ld ($+5),a
 ld hl,(.mesg)
 push hl
 ld bc,.mesg
 push bc
 ld bc, 0 + ((32+th.start.h)<<8) + (0+th.start.h)
 ld(th.new.start),bc
 ld bc,2
 push bc
 ld bc,LaserR
 push bc
 call o.new
;new LaserR{y:y+1,mesg};
 ld ($+5),a
 ld hl,(.y)
 ld de,1; const val
 add hl, de
 push hl
 ld bc,.y
 push bc
 ld ($+5),a
 ld hl,(.mesg)
 push hl
 ld bc,.mesg
 push bc
 ld bc, 0 + ((32+th.start.h)<<8) + (0+th.start.h)
 ld(th.new.start),bc
 ld bc,2
 push bc
 ld bc,LaserR
 push bc
 call o.new
;new LaserR{y:y+2,mesg};
 ld ($+5),a
 ld hl,(.y)
 ld de,2; const val
 add hl, de
 push hl
 ld bc,.y
 push bc
 ld ($+5),a
 ld hl,(.mesg)
 push hl
 ld bc,.mesg
 push bc
 ld bc, 0 + ((32+th.start.h)<<8) + (0+th.start.h)
 ld(th.new.start),bc
 ld bc,2
 push bc
 ld bc,LaserR
 push bc
 call o.new
;new LaserR{y:y+3,mesg};
 ld ($+5),a
 ld hl,(.y)
 ld de,3; const val
 add hl, de
 push hl
 ld bc,.y
 push bc
 ld ($+5),a
 ld hl,(.mesg)
 push hl
 ld bc,.mesg
 push bc
 ld bc, 0 + ((32+th.start.h)<<8) + (0+th.start.h)
 ld(th.new.start),bc
 ld bc,2
 push bc
 ld bc,LaserR
 push bc
 call o.new
L94.lb54:
;$mb=1-$mb;
 ld hl,1; const val
 ld de,(gbl_mb)
 and a
 sbc hl,de
 ld (gbl_mb),hl
;$l=100+rnd(30)-(($scm+$scb)>>1);
 ld hl,1; const val
 push hl
 ld hl,(gbl_scm)
 ld de,(gbl_scb)
 add hl, de
 pop bc
 ld b,c
L98.loop:
 sra h
 rr l
  djnz L98.loop
 push hl
 ld hl,30; const val
 call rnd
 push hl
 ld hl,100; const val
 pop de
 add hl, de
 pop de
 and a
 sbc hl,de
 ld (gbl_l),hl
L94.lb53:
;update();
 call RActor.update
 ld a,(this)
 jp L94.lb48
L94.lb49:
;updateEx(60);
 ld hl,60; const val
 push hl
 call RActor.updateEx
 ld a,(this)
L94.lb56:
;while true
 ld hl,true
 call ziffalse
 jp z,L94.lb57
;locate(12,7);
 ld hl,7; const val
 push hl
 ld hl,12; const val
 pop de
 call locate
;print("Game\u0001over");
 ld hl,L99.st
 jp L99.nx
L99.st: db 71, 97, 109, 101, 1, 111, 118, 101, 114, 0
L99.nx:
 call print.a
 ld a,(this)
;locate(10,9);
 ld hl,9; const val
 push hl
 ld hl,10; const val
 pop de
 call locate
;print("Continue\u0001Space");
 ld hl,L100.st
 jp L100.nx
L100.st: db 67, 111, 110, 116, 105, 110, 117, 101, 1, 83, 112, 97, 99, 101, 0
L100.nx:
 call print.a
 ld a,(this)
;if getkey("space")==1
 ld hl,1; const val
 push hl
 ld hl, 264
 call getkey
 pop de
 call hleqde
;then
 call ziffalse
 jp z,L94.lb58
;loadPage(Main);
;call clearInterval
 call all.die
 ld bc, 0 + ((32+th.start.h)<<8) + (0+th.start.h)
 ld(th.new.start),bc
 ld bc,0
 push bc
 ld bc,Main
 push bc
 call o.new
L94.lb58:
;update();
 call RActor.update
 ld a,(this)
 jp L94.lb56
L94.lb57:
L94.lbexit:
 ld sp,ix
 pop ix
 ret
Main.cls:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
;for i=0;
;i=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.i),hl
L101.lb59:
;while i<24
 ld hl,24; const val
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call hlltde
 call ziffalse
 jp z,L101.lb60
;for j=0;
;j=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.j),hl
L101.lb62:
;while j<32
 ld hl,32; const val
 push hl
 ld ($+5),a
 ld hl,(.j)
 pop de
 call hlltde
 call ziffalse
 jp z,L101.lb63
;map_set(j,i,$space);
 ld ($+5),a
 ld hl,(.i)
 push hl
 ld ($+5),a
 ld hl,(.j)
 push hl
 ld hl,1; const val
 ld a,l
 pop hl
 pop de
 call map.set.a
 ld a,(this)
L101.lb64:
;next j++
 ld ($+5),a
 ld hl,(.j)
 inc hl
 ld ($+5),a
 ld (.j),hl
 jp L101.lb62
L101.lb63:
L101.lb61:
;next i++
 ld ($+5),a
 ld hl,(.i)
 inc hl
 ld ($+5),a
 ld (.i),hl
 jp L101.lb59
L101.lb60:
L101.lbexit:
 ld sp,ix
 pop ix
 ret
Main.demo:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
;$demo=12345;
 ld hl,12345; const val
 ld (gbl_demo),hl
;sound_playBGM($se_iopen);
 ld hl,gbl_se_iopen; const val
 push hl
 call MZO.initBGM
 ld a,(this)
;for i=0;
;i=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.i),hl
L102.lb65:
;while i<9
 ld hl,9; const val
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call hlltde
 call ziffalse
 jp z,L102.lb66
;locate(5,i*2+3);
 ld ($+5),a
 ld hl,(.i)
 ld de,2; const val
 call mul.a
 ld a,(this)
 ld de,3; const val
 add hl, de
 push hl
 ld hl,5; const val
 pop de
 call locate
;printf("%s",$demos[i]);
 ld ($+5),a
 ld hl,(.i)
 add hl,hl
 ld de,gbl_demos; const val
 add hl,de
  ld (L103.w-2),hl
  ld hl,(0)
L103.w:
 call print.a
 ld a,(this)
 ld a,(this)
;if i==8
 ld hl,8; const val
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call hleqde
;then
 call ziffalse
 jp z,L102.lb68
 jp L102.lb66
L102.lb68:
;for j=0;
;j=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.j),hl
L102.lb69:
;while j<60&&getkey("space")!=1
 ld hl,60; const val
 push hl
 ld ($+5),a
 ld hl,(.j)
 pop de
 call hlltde
 call ziffalse
 jp z,L102.lb72
 ld hl,1; const val
 push hl
 ld hl, 264
 call getkey
 pop de
 call hlnede
L102.lb72:
 call ziffalse
 jp z,L102.lb70
;rnd(2);
 ld hl,2; const val
 call rnd
;update();
 call RActor.update
 ld a,(this)
L102.lb71:
;next j++
 ld ($+5),a
 ld hl,(.j)
 inc hl
 ld ($+5),a
 ld (.j),hl
 jp L102.lb69
L102.lb70:
;update();
 call RActor.update
 ld a,(this)
L102.lb67:
;next i++
 ld ($+5),a
 ld hl,(.i)
 inc hl
 ld ($+5),a
 ld (.i),hl
 jp L102.lb65
L102.lb66:
L102.lb73:
;while getkey("space")!=1
 ld hl,1; const val
 push hl
 ld hl, 264
 call getkey
 pop de
 call hlnede
 call ziffalse
 jp z,L102.lb74
;rnd(2);
 ld hl,2; const val
 call rnd
;update();
 call RActor.update
 ld a,(this)
 jp L102.lb73
L102.lb74:
;cls();
 call Main.cls
 ld a,(this)
L102.lbexit:
 ld sp,ix
 pop ix
 ret
; class_def_end Main
;--end RAM area
;--begin RAM area
; class_def_start Player
;range 0-32
;trace mesg
 call h.unreach
 dw RActor
Player:
; .class equ 250
 ld bc,Player
 push bc
; .statusReg equ 248
 ld bc,0
 push bc
; .main equ 246
 ld bc,Player.main
 push bc
; .x equ 244
 ld bc,0
 push bc
; .y equ 242
 ld bc,0
 push bc
; .p equ 240
 ld bc,0
 push bc
; .c equ 238
 ld bc,0
 push bc
; .onUpdate equ 236
 ld bc,RActor.onUpdate
 push bc
; .update equ 234
 ld bc,RActor.update
 push bc
; .screenOut equ 232
 ld bc,RActor.screenOut
 push bc
; .die equ 230
 ld bc,RActor.die
 push bc
; .updateEx equ 228
 ld bc,RActor.updateEx
 push bc
; .crashTo equ 226
 ld bc,RActor.crashTo
 push bc
.rc equ 224
 ld bc,0
 push bc
; .i equ 222
 ld bc,0
 push bc
 ld bc,RActor.wait
 push bc
 ld bc,o.boot
 push bc
 jp th.ewith
Player.main:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
;p=$pat_spr+4;
 ld hl,(gbl_pat_spr)
 ld de,4; const val
 add hl, de
 ld ($+5),a
 ld (.p),hl
;c=15;
 ld hl,15; const val
 ld ($+5),a
 ld (.c),hl
;x=200;
 ld hl,200; const val
 ld ($+5),a
 ld (.x),hl
;y=200;
 ld hl,200; const val
 ld ($+5),a
 ld (.y),hl
;rc=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.rc),hl
L104.lb75:
;while true
 ld hl,true
 call ziffalse
 jp z,L104.lb76
;if getkey("left")&&x>16
 ld hl, 4104
 call getkey
 call ziffalse
 jp z,L104.lb78
 ld hl,16; const val
 push hl
 ld ($+5),a
 ld hl,(.x)
 pop de
 call hlgtde
L104.lb78:
;then
 call ziffalse
 jp z,L104.lb77
;x-=4;
 ld ($+5),a
 ld hl,(.x)
 ld de,4; const val
 and a
 sbc hl,de
 ld ($+5),a
 ld (.x),hl
L104.lb77:
;if getkey("right")&&x<500
 ld hl, 32776
 call getkey
 call ziffalse
 jp z,L104.lb80
 ld hl,500; const val
 push hl
 ld ($+5),a
 ld hl,(.x)
 pop de
 call hlltde
L104.lb80:
;then
 call ziffalse
 jp z,L104.lb79
;x+=4;
 ld ($+5),a
 ld hl,(.x)
 ld de,4; const val
 add hl, de
 ld ($+5),a
 ld (.x),hl
L104.lb79:
;if getkey("up")&&y>32
 ld hl, 8200
 call getkey
 call ziffalse
 jp z,L104.lb82
 ld hl,32; const val
 push hl
 ld ($+5),a
 ld hl,(.y)
 pop de
 call hlgtde
L104.lb82:
;then
 call ziffalse
 jp z,L104.lb81
;y-=4;
 ld ($+5),a
 ld hl,(.y)
 ld de,4; const val
 and a
 sbc hl,de
 ld ($+5),a
 ld (.y),hl
L104.lb81:
;if getkey("down")&&y<360
 ld hl, 16392
 call getkey
 call ziffalse
 jp z,L104.lb84
 ld hl,360; const val
 push hl
 ld ($+5),a
 ld hl,(.y)
 pop de
 call hlltde
L104.lb84:
;then
 call ziffalse
 jp z,L104.lb83
;y+=4;
 ld ($+5),a
 ld hl,(.y)
 ld de,4; const val
 add hl, de
 ld ($+5),a
 ld (.y),hl
L104.lb83:
;rc+=(x%3+y%3)+1;
 ld ($+5),a
 ld hl,(.y)
 ld de,3; const val
 call div.a
 ex de,hl
 ld a,(this)
 push hl
 ld ($+5),a
 ld hl,(.x)
 ld de,3; const val
 call div.a
 ex de,hl
 ld a,(this)
 pop de
 add hl, de
 ld de,1; const val
 add hl, de
 push hl
 ld ($+5),a
 ld hl,(.rc)
 pop de
 add hl, de
 ld ($+5),a
 ld (.rc),hl
;if rc>200
 ld hl,200; const val
 push hl
 ld ($+5),a
 ld hl,(.rc)
 pop de
 call hlgtde
;then
 call ziffalse
 jp z,L104.lb85
;rc-=rnd(200);
 ld hl,200; const val
 call rnd
 push hl
 ld ($+5),a
 ld hl,(.rc)
 pop de
 and a
 sbc hl,de
 ld ($+5),a
 ld (.rc),hl
L104.lb85:
;if map_getAt(x,y)!=$space
 ld hl,1; const val
 push hl
 ld ($+5),a
 ld hl,(.y)
 push hl
 ld ($+5),a
 ld hl,(.x)
 pop de
 call map.getat.a
 ld h,0
 ld l,a
 ld a,(this)
 pop de
 call hlnede
;then
 call ziffalse
 jp z,L104.lb86
 jp L104.lb76
L104.lb86:
;update();
 call RActor.update
 ld a,(this)
 jp L104.lb75
L104.lb76:
;sound_playBGM($se_miss);
 ld hl,gbl_se_miss; const val
 push hl
 call MZO.initBGM
 ld a,(this)
;for rc=0;
;rc=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.rc),hl
L104.lb87:
;while rc<20
 ld hl,20; const val
 push hl
 ld ($+5),a
 ld hl,(.rc)
 pop de
 call hlltde
 call ziffalse
 jp z,L104.lb88
;for i=0;
;i=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.i),hl
L104.lb90:
;while i<3
 ld hl,3; const val
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call hlltde
 call ziffalse
 jp z,L104.lb91
;p=$pat_spr+8+i;
 ld hl,(gbl_pat_spr)
 ld de,8; const val
 add hl, de
 ld ($+6),a
 ld de,(.i)
 add hl, de
 ld ($+5),a
 ld (.p),hl
;updateEx(3);
 ld hl,3; const val
 push hl
 call RActor.updateEx
 ld a,(this)
L104.lb92:
;next i++
 ld ($+5),a
 ld hl,(.i)
 inc hl
 ld ($+5),a
 ld (.i),hl
 jp L104.lb90
L104.lb91:
L104.lb89:
;next rc++
 ld ($+5),a
 ld hl,(.rc)
 inc hl
 ld ($+5),a
 ld (.rc),hl
 jp L104.lb87
L104.lb88:
;$gov=1;
 ld hl,1; const val
 ld (gbl_gov),hl
L104.lbexit:
 ld sp,ix
 pop ix
 ret
; class_def_end Player
;--end RAM area
;--begin RAM area
; class_def_start Star
;range 0-32
;trace mesg
 call h.unreach
 dw RActor
Star:
; .class equ 250
 ld bc,Star
 push bc
; .statusReg equ 248
 ld bc,0
 push bc
; .main equ 246
 ld bc,Star.main
 push bc
; .x equ 244
 ld bc,0
 push bc
 ld bc,0
 push bc
 ld bc,0
 push bc
 ld bc,0
 push bc
; .onUpdate equ 236
 ld bc,RActor.onUpdate
 push bc
; .update equ 234
 ld bc,RActor.update
 push bc
; .screenOut equ 232
 ld bc,RActor.screenOut
 push bc
; .die equ 230
 ld bc,RActor.die
 push bc
; .updateEx equ 228
 ld bc,RActor.updateEx
 push bc
; .crashTo equ 226
 ld bc,RActor.crashTo
 push bc
.vx equ 224
 ld bc,0
 push bc
 ld bc,RActor.wait
 push bc
 ld bc,o.boot
 push bc
 jp th.ewith
Star.main:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
;x=rnd(512);
 ld hl,512; const val
 call rnd
 ld ($+5),a
 ld (.x),hl
L105.lb93:
;while 1
 ld hl,1; const val
 call ziffalse
 jp z,L105.lb94
;x-=vx;
 ld ($+5),a
 ld hl,(.x)
 ld ($+6),a
 ld de,(.vx)
 and a
 sbc hl,de
 ld ($+5),a
 ld (.x),hl
;if x<0
 ld hl,0; const val
 push hl
 ld ($+5),a
 ld hl,(.x)
 pop de
 call hlltde
;then
 call ziffalse
 jp z,L105.lb95
;x=512 ;
 ld hl,512; const val
 ld ($+5),a
 ld (.x),hl
L105.lb95:
;update();
 call RActor.update
 ld a,(this)
 jp L105.lb93
L105.lb94:
L105.lbexit:
 ld sp,ix
 pop ix
 ret
; class_def_end Star
;--end RAM area
;--begin RAM area
; class_def_start Stone
;range 0-32
;trace mesg
 call h.unreach
 dw RActor
Stone:
; .class equ 250
 ld bc,Stone
 push bc
; .statusReg equ 248
 ld bc,0
 push bc
; .main equ 246
 ld bc,Stone.main
 push bc
; .x equ 244
 ld bc,0
 push bc
; .y equ 242
 ld bc,0
 push bc
 ld bc,0
 push bc
 ld bc,0
 push bc
; .onUpdate equ 236
 ld bc,RActor.onUpdate
 push bc
; .update equ 234
 ld bc,RActor.update
 push bc
; .screenOut equ 232
 ld bc,RActor.screenOut
 push bc
; .die equ 230
 ld bc,RActor.die
 push bc
; .updateEx equ 228
 ld bc,RActor.updateEx
 push bc
; .crashTo equ 226
 ld bc,RActor.crashTo
 push bc
.vy equ 224
 ld bc,0
 push bc
; .i equ 222
 ld bc,0
 push bc
.xc equ 220
 ld bc,0
 push bc
.dir equ 218
 ld bc,0
 push bc
.erase equ 216
 ld bc,Stone.erase
 push bc
.put equ 214
 ld bc,Stone.put
 push bc
 ld bc,RActor.wait
 push bc
 ld bc,o.boot
 push bc
 jp th.ewith
Stone.main:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
;y=rnd(10)+10;
 ld hl,10; const val
 call rnd
 ld de,10; const val
 add hl, de
 ld ($+5),a
 ld (.y),hl
;vy=rnd(2)?1:-1;
 ld hl,2; const val
 call rnd
 call ziffalse
 jp z,L106.lb96
 ld hl,1; const val
 jp L106.lb97
L106.lb96:
 ld hl,1; const val
 call neghl
L106.lb97:
 ld ($+5),a
 ld (.vy),hl
;xc=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.xc),hl
;if dir<0
 ld hl,0; const val
 push hl
 ld ($+5),a
 ld hl,(.dir)
 pop de
 call hlltde
;then
 call ziffalse
 jp z,L106.lb99
;x=28;
 ld hl,28; const val
 ld ($+5),a
 ld (.x),hl
 jp L106.lb98
L106.lb99:;else
;x=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.x),hl
L106.lb98:
L106.lb100:
;while true
 ld hl,true
 call ziffalse
 jp z,L106.lb101
;erase();
 call Stone.erase
 ld a,(this)
;if xc
 ld ($+5),a
 ld hl,(.xc)
;then
 call ziffalse
 jp z,L106.lb102
;x+=dir;
 ld ($+5),a
 ld hl,(.x)
 ld ($+6),a
 ld de,(.dir)
 add hl, de
 ld ($+5),a
 ld (.x),hl
L106.lb102:
;xc=1-xc;
 ld hl,1; const val
 ld ($+6),a
 ld de,(.xc)
 and a
 sbc hl,de
 ld ($+5),a
 ld (.xc),hl
;if x<0||x>28
 ld hl,0; const val
 push hl
 ld ($+5),a
 ld hl,(.x)
 pop de
 call hlltde
 call ziffalse
 jp nz,L106.lb104
 ld hl,28; const val
 push hl
 ld ($+5),a
 ld hl,(.x)
 pop de
 call hlgtde
L106.lb104:
;then
 call ziffalse
 jp z,L106.lb103
 jp L106.lb101
L106.lb103:
;y+=vy;
 ld ($+5),a
 ld hl,(.y)
 ld ($+6),a
 ld de,(.vy)
 add hl, de
 ld ($+5),a
 ld (.y),hl
;put();
 call Stone.put
 ld a,(this)
;if y>17
 ld hl,17; const val
 push hl
 ld ($+5),a
 ld hl,(.y)
 pop de
 call hlgtde
;then
 call ziffalse
 jp z,L106.lb105
;vy=-1;
 ld hl,1; const val
 call neghl
 ld ($+5),a
 ld (.vy),hl
L106.lb105:
;if y<3
 ld hl,3; const val
 push hl
 ld ($+5),a
 ld hl,(.y)
 pop de
 call hlltde
;then
 call ziffalse
 jp z,L106.lb106
;vy=1;
 ld hl,1; const val
 ld ($+5),a
 ld (.vy),hl
L106.lb106:
;updateEx(12);
 ld hl,12; const val
 push hl
 call RActor.updateEx
 ld a,(this)
 jp L106.lb100
L106.lb101:
;die();
 call RActor.die
 ld a,(this)
L106.lbexit:
 ld sp,ix
 pop ix
 ret
Stone.erase:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
;for i=0;
;i=0;
 ld hl,0; const val
 ld ($+5),a
 ld (.i),hl
L107.lb107:
;while i<5
 ld hl,5; const val
 push hl
 ld ($+5),a
 ld hl,(.i)
 pop de
 call hlltde
 call ziffalse
 jp z,L107.lb108
;locate(x,y+i);
 ld ($+5),a
 ld hl,(.y)
 ld ($+6),a
 ld de,(.i)
 add hl, de
 push hl
 ld ($+5),a
 ld hl,(.x)
 pop de
 call locate
;print("\u0001\u0001\u0001\u0001");
 ld hl,L108.st
 jp L108.nx
L108.st: db 1, 1, 1, 1, 0
L108.nx:
 call print.a
 ld a,(this)
L107.lb109:
;next i++
 ld ($+5),a
 ld hl,(.i)
 inc hl
 ld ($+5),a
 ld (.i),hl
 jp L107.lb107
L107.lb108:
L107.lbexit:
 ld sp,ix
 pop ix
 ret
Stone.put:
;  arg2 arg1 retad oldix lcl1 lcl2
 push ix
 ld ix,0
 add ix,sp
;if dir>0
 ld hl,0; const val
 push hl
 ld ($+5),a
 ld hl,(.dir)
 pop de
 call hlgtde
;then
 call ziffalse
 jp z,L109.lb111
;locate(x+1,y+0);
 ld hl,0; const val
 push hl
 ld ($+5),a
 ld hl,(.y)
 pop de
 add hl, de
 push hl
 ld ($+5),a
 ld hl,(.x)
 ld de,1; const val
 add hl, de
 pop de
 call locate
;print(    "\u000d\u000e");
 ld hl,L110.st
 jp L110.nx
L110.st: db 13, 14, 0
L110.nx:
 call print.a
 ld a,(this)
;locate(x+1,y+1);
 ld ($+5),a
 ld hl,(.y)
 ld de,1; const val
 add hl, de
 push hl
 ld ($+5),a
 ld hl,(.x)
 ld de,1; const val
 add hl, de
 pop de
 call locate
;print(    "\u0015\u0016");
 ld hl,L111.st
 jp L111.nx
L111.st: db 21, 22, 0
L111.nx:
 call print.a
 ld a,(this)
;locate(x,y+2);
 ld ($+5),a
 ld hl,(.y)
 ld de,2; const val
 add hl, de
 push hl
 ld ($+5),a
 ld hl,(.x)
 pop de
 call locate
;print("\u001c\u001d\u001e\u001f");
 ld hl,L112.st
 jp L112.nx
L112.st: db 28, 29, 30, 31, 0
L112.nx:
 call print.a
 ld a,(this)
;locate(x,y+3);
 ld ($+5),a
 ld hl,(.y)
 ld de,3; const val
 add hl, de
 push hl
 ld ($+5),a
 ld hl,(.x)
 pop de
 call locate
;print("\u0024\u0025\u0026\u0027");
 ld hl,L113.st
 jp L113.nx
L113.st: db 36, 37, 38, 39, 0
L113.nx:
 call print.a
 ld a,(this)
;locate(x,y+4);
 ld ($+5),a
 ld hl,(.y)
 ld de,4; const val
 add hl, de
 push hl
 ld ($+5),a
 ld hl,(.x)
 pop de
 call locate
;print("\u002c\u002d\u002e\u002f");
 ld hl,L114.st
 jp L114.nx
L114.st: db 44, 45, 46, 47, 0
L114.nx:
 call print.a
 ld a,(this)
 jp L109.lb110
L109.lb111:;else
;locate(x+1,y+0);
 ld hl,0; const val
 push hl
 ld ($+5),a
 ld hl,(.y)
 pop de
 add hl, de
 push hl
 ld ($+5),a
 ld hl,(.x)
 ld de,1; const val
 add hl, de
 pop de
 call locate
;print(      "\u0009\u000a");
 ld hl,L115.st
 jp L115.nx
L115.st: db 9, 10, 0
L115.nx:
 call print.a
 ld a,(this)
;locate(x+0,y+1);
 ld ($+5),a
 ld hl,(.y)
 ld de,1; const val
 add hl, de
 push hl
 ld hl,0; const val
 push hl
 ld ($+5),a
 ld hl,(.x)
 pop de
 add hl, de
 pop de
 call locate
;print("\u0010\u0011\u0012\u0013");
 ld hl,L116.st
 jp L116.nx
L116.st: db 16, 17, 18, 19, 0
L116.nx:
 call print.a
 ld a,(this)
;locate(x,y+2);
 ld ($+5),a
 ld hl,(.y)
 ld de,2; const val
 add hl, de
 push hl
 ld ($+5),a
 ld hl,(.x)
 pop de
 call locate
;print("\u0018\u0019\u001a\u001b");
 ld hl,L117.st
 jp L117.nx
L117.st: db 24, 25, 26, 27, 0
L117.nx:
 call print.a
 ld a,(this)
;locate(x+1,y+3);
 ld ($+5),a
 ld hl,(.y)
 ld de,3; const val
 add hl, de
 push hl
 ld ($+5),a
 ld hl,(.x)
 ld de,1; const val
 add hl, de
 pop de
 call locate
;print("\u0021\u0022");
 ld hl,L118.st
 jp L118.nx
L118.st: db 33, 34, 0
L118.nx:
 call print.a
 ld a,(this)
;locate(x+1,y+4);
 ld ($+5),a
 ld hl,(.y)
 ld de,4; const val
 add hl, de
 push hl
 ld ($+5),a
 ld hl,(.x)
 ld de,1; const val
 add hl, de
 pop de
 call locate
;print("\u0029\u002a");
 ld hl,L119.st
 jp L119.nx
L119.st: db 41, 42, 0
L119.nx:
 call print.a
 ld a,(this)
L109.lb110:
L109.lbexit:
 ld sp,ix
 pop ix
 ret
; class_def_end Stone
;--end RAM area
;--begin RAM area
gbl_players:
 ds 8,0
gbl_colors:
 dw 9, 7, 3, 11
gbl_scb:dw 0
gbl_scm:dw 0
gbl_demo:dw 0
gbl_gov:dw 0
gbl_s:dw 0
gbl_score:dw 0
gbl_l:dw 0
gbl_mb:dw 0
gbl_smb:dw 0
gbl_pat_spr:dw 0
gbl_mesg:
 db 72, 101, 108, 108, 111, 44, 32, 119, 111, 114, 108, 100, 0
gbl_mesgs:
 dw gbl_mesgs_0
 dw gbl_mesgs_1
gbl_mesgs_0:
 db 72, 101, 108, 108, 111, 0
gbl_mesgs_1:
 db 87, 111, 114, 108, 100, 33, 33, 0
gbl_lasers:
 dw gbl_lasers_0
 dw gbl_lasers_1
 dw gbl_lasers_2
 dw gbl_lasers_3
 dw gbl_lasers_4
 dw gbl_lasers_5
 dw gbl_lasers_6
 dw gbl_lasers_7
 dw gbl_lasers_8
 dw gbl_lasers_9
 dw gbl_lasers_10
 dw gbl_lasers_11
 dw gbl_lasers_12
 dw gbl_lasers_13
 dw gbl_lasers_14
 dw gbl_lasers_15
 dw gbl_lasers_16
 dw gbl_lasers_17
 dw gbl_lasers_18
 dw gbl_lasers_19
gbl_lasers_0:
 db 151, 233, 154, 239, 156, 222, 227, 222, 224, 222, 146, 157, 151, 151, 233, 154
 db 239, 156, 222, 227, 222, 149, 156, 227, 222, 157, 151, 233, 154, 228, 227, 243
 db 149, 157, 157, 242, 151, 233, 154, 239, 156, 222, 227, 222, 149, 146, 156, 146
 db 0
gbl_lasers_1:
 db 151, 233, 154, 224, 222, 146, 157, 151, 151, 233, 154, 158, 222, 143, 224, 146
 db 149, 156, 227, 222, 157, 151, 233, 154, 158, 222, 143, 224, 146, 155, 146, 154
 db 147, 151, 233, 154, 234, 239, 249, 0
gbl_lasers_2:
 db 151, 233, 154, 228, 227, 243, 234, 239, 249, 151, 233, 154, 150, 222, 225, 227
 db 222, 155, 146, 154, 147, 151, 233, 154, 228, 227, 243, 149, 156, 227, 222, 157
 db 151, 233, 154, 158, 222, 143, 224, 146, 234, 239, 249, 0
gbl_lasers_3:
 db 151, 233, 154, 239, 156, 222, 227, 222, 234, 239, 249, 151, 233, 154, 228, 227
 db 243, 234, 239, 249, 151, 233, 154, 158, 222, 143, 224, 146, 146, 224, 222, 146
 db 151, 233, 154, 158, 222, 143, 224, 146, 149, 156, 227, 222, 157, 0
gbl_lasers_4:
 db 151, 233, 154, 224, 222, 146, 157, 151, 151, 233, 154, 158, 222, 143, 224, 146
 db 155, 146, 154, 147, 151, 233, 154, 228, 227, 243, 234, 239, 249, 151, 233, 154
 db 158, 222, 143, 224, 146, 149, 146, 156, 146, 0
gbl_lasers_5:
 db 151, 233, 154, 157, 154, 222, 152, 155, 146, 154, 147, 151, 233, 154, 150, 222
 db 225, 227, 222, 148, 247, 146, 151, 233, 154, 157, 154, 222, 152, 149, 156, 227
 db 222, 157, 151, 233, 154, 150, 222, 225, 227, 222, 234, 239, 249, 0
gbl_lasers_6:
 db 151, 233, 154, 242, 143, 225, 140, 149, 146, 156, 146, 151, 233, 154, 228, 227
 db 243, 155, 146, 154, 147, 151, 233, 154, 239, 156, 222, 227, 222, 146, 224, 222
 db 146, 151, 233, 154, 150, 222, 225, 227, 222, 147, 239, 146, 0
gbl_lasers_7:
 db 151, 233, 154, 158, 222, 143, 224, 146, 234, 239, 249, 151, 233, 154, 242, 143
 db 225, 140, 234, 239, 249, 151, 233, 154, 242, 143, 225, 140, 234, 239, 249, 151
 db 233, 154, 150, 222, 225, 227, 222, 146, 224, 222, 146, 0
gbl_lasers_8:
 db 151, 233, 154, 239, 156, 222, 227, 222, 148, 247, 146, 151, 233, 154, 242, 143
 db 225, 140, 224, 222, 146, 157, 151, 151, 233, 154, 228, 227, 243, 148, 247, 146
 db 151, 233, 154, 239, 156, 222, 227, 222, 149, 156, 227, 222, 157, 0
gbl_lasers_9:
 db 151, 233, 154, 147, 239, 146, 151, 233, 154, 242, 143, 225, 140, 155, 146, 154
 db 147, 151, 233, 154, 147, 239, 146, 151, 233, 154, 149, 157, 157, 242, 151, 233
 db 154, 150, 222, 225, 227, 222, 146, 224, 222, 146, 0
gbl_lasers_10:
 db 224, 153, 233, 154, 147, 239, 146, 224, 153, 233, 154, 150, 222, 225, 227, 222
 db 234, 239, 249, 224, 153, 233, 154, 150, 222, 225, 227, 222, 149, 146, 156, 146
 db 224, 153, 233, 154, 242, 143, 225, 140, 224, 222, 146, 157, 151, 0
gbl_lasers_11:
 db 224, 153, 233, 154, 157, 154, 222, 152, 155, 146, 154, 147, 224, 153, 233, 154
 db 242, 143, 225, 140, 148, 247, 146, 224, 153, 233, 154, 150, 222, 225, 227, 222
 db 234, 239, 249, 0
gbl_lasers_12:
 db 224, 153, 233, 154, 242, 143, 225, 140, 224, 222, 146, 157, 151, 224, 153, 233
 db 154, 239, 156, 222, 227, 222, 155, 146, 154, 147, 224, 153, 233, 154, 150, 222
 db 225, 227, 222, 147, 239, 146, 0
gbl_lasers_13:
 db 224, 153, 233, 154, 150, 222, 225, 227, 222, 146, 224, 222, 146, 224, 153, 233
 db 154, 242, 143, 225, 140, 155, 146, 154, 147, 224, 153, 233, 154, 239, 156, 222
 db 227, 222, 149, 146, 156, 146, 0
gbl_lasers_14:
 db 224, 153, 233, 154, 150, 222, 225, 227, 222, 234, 239, 249, 224, 153, 233, 154
 db 242, 143, 225, 140, 234, 239, 249, 224, 153, 233, 154, 158, 222, 143, 224, 146
 db 224, 222, 146, 157, 151, 0
gbl_lasers_15:
 db 224, 153, 233, 154, 228, 227, 243, 149, 156, 227, 222, 157, 224, 153, 233, 154
 db 239, 156, 222, 227, 222, 224, 222, 146, 157, 151, 224, 153, 233, 154, 147, 239
 db 146, 224, 153, 233, 154, 157, 154, 222, 152, 149, 156, 227, 222, 157, 0
gbl_lasers_16:
 db 224, 153, 233, 154, 157, 154, 222, 152, 234, 239, 249, 224, 153, 233, 154, 150
 db 222, 225, 227, 222, 149, 146, 156, 146, 224, 153, 233, 154, 150, 222, 225, 227
 db 222, 149, 157, 157, 242, 0
gbl_lasers_17:
 db 224, 153, 233, 154, 228, 227, 243, 155, 146, 154, 147, 224, 153, 233, 154, 157
 db 154, 222, 152, 149, 157, 157, 242, 224, 153, 233, 154, 158, 222, 143, 224, 146
 db 149, 157, 157, 242, 0
gbl_lasers_18:
 db 224, 153, 233, 154, 158, 222, 143, 224, 146, 148, 247, 146, 224, 153, 233, 154
 db 239, 156, 222, 227, 222, 155, 146, 154, 147, 224, 153, 233, 154, 147, 239, 146
 db 224, 153, 233, 154, 157, 154, 222, 152, 149, 157, 157, 242, 0
gbl_lasers_19:
 db 224, 153, 233, 154, 239, 156, 222, 227, 222, 146, 224, 222, 146, 224, 153, 233
 db 154, 234, 239, 249, 224, 153, 233, 154, 228, 227, 243, 146, 224, 222, 146, 224
 db 153, 233, 154, 150, 222, 225, 227, 222, 155, 146, 154, 147, 0
gbl_demos:
 dw gbl_demos_0
 dw gbl_demos_1
 dw gbl_demos_2
 dw gbl_demos_3
 dw gbl_demos_4
 dw gbl_demos_5
 dw gbl_demos_6
 dw gbl_demos_7
 dw gbl_demos_8
gbl_demos_0:
 db 252, 250, 252, 250, 234, 1, 225, 151, 141, 147, 150, 222, 146, 1, 158, 146
 db 242, 146, 224, 146, 228, 233, 0
gbl_demos_1:
 db 1, 1, 1, 158, 253, 159, 147, 230, 1, 145, 153, 152, 250, 227, 146, 224
 db 0
gbl_demos_2:
 db 1, 1, 226, 146, 230, 1, 252, 150, 222, 1, 158, 253, 228, 147, 151, 234
 db 0
gbl_demos_3:
 db 1, 227, 151, 233, 1, 225, 141, 147, 157, 147, 233, 1, 146, 248, 152, 222
 db 225, 230, 0
gbl_demos_4:
 db 1, 1, 1, 224, 228, 222, 248, 226, 152, 154, 228, 150, 222, 227, 222, 151
 db 224, 0
gbl_demos_5:
 db 1, 1, 156, 150, 156, 1, 252, 250, 252, 250, 234, 1, 156, 247, 229, 150
 db 143, 224, 0
gbl_demos_6:
 db 1, 1, 246, 248, 1, 156, 253, 154, 152, 229, 162, 158, 253, 159, 147, 163
 db 230, 0
gbl_demos_7:
 db 1, 146, 226, 233, 239, 230, 150, 1, 239, 151, 154, 239, 250, 227, 1, 146
 db 224, 154, 228, 134, 0
gbl_demos_8:
 db 1, 1, 1, 80, 114, 101, 115, 115, 1, 83, 112, 97, 99, 101, 1, 75
 db 101, 121, 0
;--end RAM area
 end _main